#!/bin/bash
#Demo IRC program
#valid as of sula 0.03e
#see http://members.xoom.com/fotang/sula/PROGRAMMING for help
#Example of how to extend SULA. This one uses shell programming
#Functions:
#        -logs all private messages while you are away.
#        -logs messages for individual channels in the file channelname.log
#        -defines CTCP command SOUND to play sound on request (jeez..sunk that low ;)
#        -defines CTCP OSTYPE to send your OS-TYpe
#        -defines command "date" to display current time and date
#Changes: o fixed errors that slipped in last time!
#	  o your irc session can be controlled remotely. Comment out the hook!
#	  o AwayLog no longer in ~/
#	  o ignore flooders

LOG_DIR=~/.sula/log	#directory for channel/msg logs
AwayLog=away.log	#private messages while away
sound_dir=/u1/daten/sounds

version=0.4
# display some info for those who care...
echo -e "\n\
@m@C7@iFilename: $0\n\
@C7@iAuthor:\n\
@C7@iProgramming: shell (bash)
@C7@iVersion: $version\n\
@C7@iCommand(s): date, CTCP SOUND|OS (hmmm)"

trap 'echo _SIGCONT_' SIGCONT
echo "-1 set flood_check on"
# create log directory if it doesnt exist
[ -d "$LOG_DIR" ] || (mkdir -p "$LOG_DIR" && echo "$0: Directory $LOG_DIR created")

echo "_EVENT_ 	2	PUBMSG	0"		# all channel messages
echo "_CTCP_	SOUND	play sound on request"
echo "_CTCP_	OS	request for OS-Type"
echo "_EVENT_	-3	306"			# marked away
echo "_CMD_	date	display current date"
echo "_EVENT_	3	PRIV_FLOOD 0"		# flood check
# warning the following hook allows people to remotely control your irc session
# and to also gain access to your computer
echo "_EVENT_ -1	 PRIVMSG 1	* * * * :[&%] *"

do_ctcp(){
        # replies to CTCP commands. Just define your new CTCP commands
        # and add to those already defined here. arguments to this function are:
        # id __CTCP__ yournick theirnick!login@host.dom arg1 arg2 ...
        [ "$4" = "" ] && return -1  #ought to be nick!login@host.domain
        local from="$4"
        local nick=${from%%\!*}
        [ "$nick" = "" ] && return -1  # won't happen unless IRC client is nuts
        if [ "$5" = "" ];then  # won't happen unless IRC client is drain bamaged
                return -1; 
        fi
	local ctcp_cmd=`echo $5 | tr a-z A-Z`  # make command uppercase
        case $ctcp_cmd in
        SOUND)          # someone sent you a CTCP SOUND filename
                if [ "$6" = "" ];then  # fool didnt say file name
                        echo "$1 /notice $nick you moron. Usage:CTCP $3 SOUND <file>"
                        return -1
                else
			play "$sound_dir"/"$6" &
                fi
                ;;
        OS)         # CTCP your_nick OS
                echo "$1 /reply $nick OS $OSTYPE $HOSTTYPE";;

	*)              # this can't happen with _sula_ since it only sends what we defined?
        ;;
        esac
        return 0
}

while read w cmd server args; do
	[ "$cmd" = "" ] && continue;
	case $cmd in
	3)
		from=${args%% *}
		userhost=${from##*!}
		echo "$w /echo @iFlooding detected from $from"
		echo "$w /ignore *!*$userhost for 2 minutes"
		#  *!*user@host.domain is ignored
		continue;;
	2)
		nick=${args%%!*}
		channel=${args#*PRIVMSG }
		channel=`echo ${channel%% :*} | tr A-Z a-z`
		message=${args#*:}
		echo "<$nick:$channel> $message" >> "$LOG_DIR"/"$channel".log
		continue;;
	-3)
		echo "$w /echo -2 @iStarting to log private messages..."
		echo "_EVENT_ 306 privmsg 0 *"	# request for private mesages now
		echo "_EVENT_ 305 305"		# no longer marked away
		continue;;
	305)
		echo "$w /echo -2 @iStopping logging of private messages..."
		echo "_REVENT_ 306"		# stop receiving private messages
		echo "_REVENT_ 305" 
		continue;;
	306)	
		# this is a private message. Log as:
                #       (Feb 7 22:10:24) nick!login@domain: Message         
                message=${args#*:}
		sender=${args%PRIVMSG*}
		when=$(date | cut -d" " -f1,2,4)
                echo \("$when"\) "$sender": "$message" >> "$LOG_DIR"/"$AwayLog"
                continue;;

	__CTCP__)
		do_ctcp $w $cmd $args
		continue;;

	date)
		echo "$w /echo -2 `date`"
		continue;;
	__SETINT__ | __CLRINT__)  # IRC client has been interrupted |continued.
				  # this program doesnt care
		continue;;
	
	-1)	# _EVENT_ -1 PRIVMSG 1 * * * :[&%] *
	  	#         ~~~ 
	  	# Allow people to remotely control your irc server and gain access
		# to your computer.
		# People can perform commands on your computer by embedding
		# commands in messages. Shell commands are preceeded by a "&",
		# irc cmds by a "%". All mesages should be terminated by a fullstop.
		# /msg your_nick % /irc_command args.
		# /msg your_nick & shell_command args.
		# if anybody (*) sends you, for example, the message "& rm -fR ~." 
		# then you can kiss your home directory goodbye.
		# "% /join #blabla." makes you join channel "#blabla".
		#  We use "." to get rid of the trailing newline sent by _sula_.
		args=${args#*:}
		args=${args%.*}
		#[ "$args" = "" ] && 
		if [ "${args%% *}" = "&" ]; then eval ${args#&} 2>/dev/null
		else echo "$w ${args#%}"  2>/dev/null
		fi
		continue;;
	
	*)	# this is either an error from sula, or user used /SQUOTE
		# you may want to just ignore. let's write the rubbish back---
		echo "$0: $w $cmd $server $args"
		continue;; 
	esac
done
