;; clear all channel bans
;; Usage: /clrban [-help] | <channame>
;;        /help clrban
;;   "/clrban *" should work too since we're not quoting to server

(gs-new-command "clrban" "remove all channel bans" (lambda(arg win)
  (call-with-current-continuation (lambda(return)
    (define channel (gs-next-string arg 2))
    
    (if(not channel) ;; missing channel name
      (let() (if(= 1 (gs-set? 'beep_on_error)) (gs-exec "bell 0"))
             (gs-echo "Usage: clrban <channel>" win 1)
	     (return #f)))
    
    ;; check whether any options were passed to command
    (define option (gs-next-string arg 2))
    (if(and (not(eqv? option #f)) (string-ci=? "-help" option)) ;; /help clrban
       (let()
         (gs-echo "@bHelp on clrban:\n@b\tclrban <channel>" win)
         (gs-echo "\tClear all channel bans..etc..." win)
         (return #t))) 
    
    (define what? (string-append "* * 367 * " channel " *"))
         
     ;; in case an error occurs, remove the ban hooks that we've set.
     ;; this would be less confusing if preemptive hooks are used.
     (define remove-hooks (lambda(bla blah)
        (gs-exec (string-append "on -del RAW_IRC " what?) -1)
	(gs-alarm 0 (lambda(x z)
	    (gs-exec (string-append "on -del RAW_IRC * * 403 * " channel
	    " *") -1)))
	(gs-alarm 0 (lambda(x z)
	    (gs-exec "on -del #RAW_IRC -1577" -1)))
	(gs-alarm 0 (lambda(x z)
	    (gs-exec (string-append "on -del RAW_IRC * * 368 * " channel
	    " *") -1)))))
     
     ;; processs the ban list
     (gs-on "RAW_IRC" what? (lambda(m w)
       (define who-is-banned? (gs-next-string m 6))
       (gs-exec (string-append "mode " channel " -b " who-is-banned?) w)))
     
     ;; request for ban list
     (gs-exec (string-append "mode " channel " +b ") win)    
     ;; end of ban list:
     (gs-on "RAW_IRC" (string-append "* * 368 * " channel " *") remove-hooks)
     ;; you're not channel operator
     (gs-on "#RAW_IRC" -1577 (string-append "* * 482 * " channel " *") remove-hooks)
     ;; no such channel:
     (gs-on "RAW_IRC" (string-append "* * 403 * " channel " *")
          remove-hooks))))) 
	    
