; Examples of hooks on named connections NC

;; NC_LOST
;; NC_LOST hooks are triggered when a NC is closed or lost.
;; <name> and <sp> are arguments to the hook procedure.
;; <name> is the name of the NC, <sp> is its numeric ID as
;; can be passed as argument to gs-nc.
;;
(gs-on "#NC_LOST" 100 "*" (lambda(name sp)
  (gs-echo (s-print "Connection " sp "(" name ") lost") -1)))
 
;; NC
;; NC hooks are triggered whenever something is read from a named
;; connection. <str> and <sp> are arguments to the hook procedure.
;; str := <name> <message read>
;; <sp> is the ID of the NC 
 
(gs-preempt "#NC" 100  "*" (lambda(str sp)

;; We assume that the format of <str> follows the named connection rule
;; described in PROGRAMMING-2.txt. Hence,
;; str:=<name> <ident> <rest>
;; We assume that ident is a window number. If <ident> isnt numeric,
;; we display message using the control window. Otherwise, we return non
;; #f and let client handle the message.

  (define ident (string->number (gs-next-string str 2)))
  (if(not ident)
    (let* ((name (gs-next-string str 1))
           (rest (substring str (string-length name) (string-length str))))
           (gs-echo (s-print name "[" sp "]> " rest) -1) #t)
    #f)))
  
