/* cmd.c	- client commands.
		more in cmd_defs.c

    Author: Tano Fotang, 1997,1998

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License , or
    (at your option) any later version.

    see the file COPYING for details.

*/




#include <forms.h>
#include <ctype.h>
#include "config.h"
#include "nicks.h"
#include "aux.h"
#include "sula.h"
#include "chanwin.h"
#include "global.h"
#include "script_gui.h"
#include "ignore.h"
#include "setting.h"
#include "dcc.h"
#include "cmd.h"
#include "cmd_def.h"
#include "help.h"
#include "parser.h"
#include "flood.h"
#include "timer.h"
#include "script.h"
#include "scheme.h"
#include "hooks.h"

extern FD_scriptcontrol *script_form;
static int argc;
static CmdStruct *cs;	/* routines calling *process-cmd() must declare this again!*/

static void history_cmd(void *data){
	
	char *argv[12];

       	cs=(CmdStruct *)data ;
	new_str2args(cs->args, &argc,argv, 12);
	history(argc, argv, cs->win);
}
static void ignore_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	ignore(argc, argv,cs->win);
}

static void join_cmd(void *data){
	
	char *argv[12];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, 12);
	join(argc, argv, cs->win);
}
static void invite_cmd(void *data){
	char *argv[MAXARGC];
	
	CmdStruct *cs=(CmdStruct *)data;

	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv,MAXARGC);
	invite(argc, argv, cs->win);
}
static void part_cmd(void *data){
	
	char *argv[5];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv,5);
	part(argc, argv, cs->win);
}

static void topic_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	topic(argc, argv, cs->win);
}
static void quit_cmd(void *data){
/* 
 * /quit       :close connecton to server /quit <reason>
 * /quit -f    :ignore all hooks set on SIGNOFF
 */
	

       	cs=(CmdStruct *)data ;

	  if(!cs->win || !cs->win->server || cs->win->server->fd<0)
	      {
	      if (gflags & BEEP_ERR) fl_ringbell(0);
               return;}
   else{
	static char quitting=0;
	  char force=0;
	  int done;
	  char *arg=nextstr(cs->args,2);
	  done=0;
	  if(*arg) //  use </quit -f to really quit
	    if(*arg=='-' && (arg[1]=='f' ||arg[1]=='F')){
	     done=1; force=1;
	     }
	  if(!done){
	  if(quitting) {free(arg);return;}
	  quitting=1; // stop endless loop from hook handler
	  done= !check_msg_hook(SIGNOFF,cs->win-winstruct,"%s,%d %s",
	  cs->win->server->name,cs->win->server->port,cs->win->server->nick);
	  }
	   free(arg);
	   if(done){
		char    buf[225];
		WinList *p;
		int ret;

		if(force) arg= cs->args+find_pos(cs->args,3);
		else arg=cs->args+find_pos(cs->args,2);
		if (*arg == 0)
		      ret=snprintf(buf,225, "QUIT :%s\n", quit_text);
		else 
		      ret=snprintf(buf,225, "QUIT :%s\n",arg);
		if(ret==-1) buf[225]=0;
		sendto_server(cs->win, buf);
		build_winlistbyfd(cs->win->server->fd);
		p = servWin;
		while (p) {
			ClearWinChanList(p->win);
			UpdateStatus(p->win);
			p = p->next;
		}
		close_server_connection(&cs->win->server->fd);
	 }
	 quitting=0;
	}
}
static void window_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if(!cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	window(argc, argv, cs->win);
}

static void empty_cmd(void *data){
}

static void on_cmd(void *data){
/*
express hook cmd! Use Scheme functions to set *real* hooks.
Window not needed. Examples:
-we dont want to see who created channel:
on 329 * :
-and who set topic:
on 333 * :

on #pubmsg 100 "* * * *silly*" /notice $3 No more silliness, please!
on #topic 100 "* * #4 *" /action $3 hates topic changes on channel #4.
on CTCP_REPLY "* * * *ERRMSG *SED*" :
on finger * /reply $3 FINGER Keep your damn fingers to yourself!

For complicated hooks, use Scheme code:
gs-on blablabla functionToCall. See gsula doc.
*/
	On w;
	char *cmd,*junk;
	char *str;
	int num=-1, pos=3, n;
	char *tt, *tmp, *args=NULL;
	
	cs=(CmdStruct *)data;
	
	junk=nextstr(cs->args,2);

	if(!*junk){
		//hook_list(cs->win?cs->win->chanwin->browser:main_form->browser,
		//0,1);
		say(PROMPT"currently cant list",cs->win?cs->win-winstruct:-1,1);
		free(junk);return;
	}else {cmd=alloca(sizeof(char)*(1+strlen(junk)));strcpy(cmd,junk);}
	free(junk);
	if(!strncasecmp(cmd,"-del",4)){
		del_hook(cs->args+find_pos(cs->args,3));
		return;
	}
	str=cs->args;
	w.ser_number=0;
#define s_error() \
		say("Unterminated \" or missing pattern or numeric", \
		cs->win?cs->win-winstruct:-1,1)
	if(*cmd=='#') {
		pos=4;
		n=sscanf(str, "%*s %*s %d", &w.ser_number);
		if(n<1 || (*++cmd=='\0')) {s_error(); return;}
	};
	w.flag=HK_IN;
	w.cmd.cmd=NULL;
	w.pattern=NULL;
	w.id=-1;
	tt=nextstr(str, pos);
	if(!*tt) {s_error();free(tt); return;}
	tmp=alloca(sizeof(char)*strlen(cs->args));
	args=alloca(sizeof(char)*strlen(cs->args));
	if(*tt=='"'){
		if(pos==4)
		   n=sscanf(str, "%*s %*s %*s \"%[^\"]\" %[^\n]\n",tmp, args);
	       	else
		   n=sscanf(str, "%*s %*s \"%[^\"]\" %[^\n]\n",tmp, args);
	}
	else{
		
		if(pos==4) n=sscanf(str, "%*s %*s %*s %s %[^\n]\n", tmp,args);
		else n=sscanf(str, "%*s %*s %s %[^\n]\n", tmp, args);
		
	}
	free(tt);
	if(n<2) {s_error(); return;}
	w.pattern=strdup(tmp);
	w.cmd.cmd=strdup(args);
	num=strtol(cmd, &tt,0);
	if(*tt){
	 	MsgNr type=get_type(cmd);
	 	if(type!=INVALID){
			 add_hook(type, &w);
			 if(script_form) list_hooks(1);
		}
	 	else say2(cs->win?cs->win-winstruct:-1,1,
		"Unknown message type:%s\n", cmd);
	}else if( num>0){
		add_numhook(num, &w);
		if(script_form) list_hooks(1);
	}
	else
		say2(cs->win?cs->win-winstruct:-1,1,
		"invalid numeric (%d)?\n",num);
	free(w.pattern); 
	free(w.cmd.cmd);
}	

static void bell_cmd(void *data){
	CmdStruct *cs=(CmdStruct *)data;
	char *arg=nextstr(cs->args,2);
	   fl_ringbell( (*arg?atoi(arg):0) % 100);
	free(arg);
}

static void exit_cmd(void *data){
	CmdStruct *cs=(CmdStruct *)data;
	char *arg;

	arg=nextstr(cs->args,2);
	if(*arg==0)
	  if(main_form) fl_trigger_object(main_form->quit);
	else
	if ( *arg=='-' && (arg[1]=='f' || arg[1]=='F')) {
		fl_finish();
		exit(0);
	}
	free(arg);
}
static void lag_cmd(void *data){
	CmdStruct *cs=(CmdStruct *)data;

	if( !cs->win) return;
	else
	 fl_trigger_object(cs->win->chanwin->lag);
}


static void set_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	new_str2args(cs->args, &argc,argv, MAXARGC);

	set(argc, argv, cs->win);
}

static void whatis_cmd(void *data){
	
	
	char *argv[3];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, 3);
	whatis(argc, argv, cs->win);
	return;
}

static void encrypt_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	
	do_encrypt(argc, argv, cs->win);
	return;
}

static void apropos_cmd(void *data){
	/*static void apropos(int argc, char **argv, Winstruct *win);*/
	
	char *argv[3];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, 3);
	apropos2(argc, argv, cs->win);
	return;
}

static void help_cmd(void *data){
	
	char *argv[4];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, 4);
	
	help(argc, argv, cs->win);
	return;
}

static void shell_cmd(void *data){
/*	/!ls -l or /! ls -l  */
	cs=(CmdStruct *)data;
	    rmstr(cs->args,0);
	   if(cs->args && *(cs->args)){
		fl_show_command_log(FL_FULLBORDER);
		 fl_exe_command(cs->args, 0);
	   }
}


static void warranty_cmd(void *data){
/* bugs && warranty */
	
	cs=(CmdStruct *)data;
	if( access( warranty_file, R_OK)==0){
		fl_load_browser(cs->win?cs->win->chanwin->browser:
		main_form->browser,
			warranty_file);
	}else {
		char *buf=(char *)malloc(sizeof(char)*(strlen(PROMPT)+
		strlen(warranty_file)+300));
		sprintf(buf,PROMPT"%s: %s", warranty_file, strerror(errno));
		fl_addto_browser(
		cs->win?cs->win->chanwin->brow2:main_form->browser,buf);
		free(buf);
	}
}


/* list all channels on this window */
static void lch_cmd(void *data){
	
	Channel *current;

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	else{
	int i=1;
	current=cs->win->chanStart->left;
	while(current!=cs->win->chanStart){
		char buf[128];
		sprintf(buf,"%s\t%d. %s", current==cs->win->chanCur?"*":"",
		i++, current->name);
		fl_addto_browser(cs->win->chanwin->brow2, buf);
		current=current->left;
	}
  }
}

static void lg_cmd(void *data){
/* list allchannels*/

	gChannel *p=chanStart;
	char buf[256];
	unsigned char i=1;
	cs=(CmdStruct *)data;
	while(p!=chanEnd){
		sprintf(buf, "\t%d. %-*s on %s (%d)",i++,
		MaxChanLen, p->name, p->server, p->port);
		say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}
}
static void lu_cmd(void *data){
/* list users in curren channel */
	cs=(CmdStruct *)data;
	if( !cs->win) return;
	   if( cs->win->chanCur!=cs->win->chanStart) {
		char buf[256];
		Channel *p=cs->win->chanCur;
		User	*u;
		sprintf(buf, "@b@fInternal user list for %s",p->name);
		u=p->userStart;
		while(u!=p->userEnd){
			sprintf(buf, "@f%-*.*s %-4s %s (%s)", MaxNickLen+2,MaxNickLen,
			 u->name,u->mode,u->address,
			 u->ircname?u->ircname:"(null): update?");
			fl_addto_browser(cs->win->chanwin->browser, buf);
			u=u->next;
		}
	}
}


static void fwdcr_cmd(void *data){
/* forward a chat req received*/
	
	cs=(CmdStruct *)data;
	if(!cs->win) return;
   {
	ChatReqRecvd *q=chatreqStart;
	int id;
	char *nick;
	rmstr(cs->args,0);
	if(*cs->args==0) return;
	nick=(char*)alloca(sizeof(char)*strlen(cs->args));
	if(sscanf(cs->args,"%u %s", &id, nick)<2) return;
	while(q!=chatreqEnd)
		if(q->id==id){
			ChatReqRecvd *p=q->next;
			char buf[512];
			sprintf(buf, "PRIVMSG %s :%cDCC CHAT chat %lu %u%c\r\n",
				nick, 0x01,q->inetaddr, q->port,0x01);
			sendto_server(cs->win, buf);
			if(gflags & RM_ON_FWD){
				free(q->nick); free(q->email);
				if(p==chatreqEnd) chatreqEnd=q;else *q=*p; free(p);
			}
			break;
		}
		else q=q->next;
   }
}
static void fwdfr_cmd(void *data){
/*forward a file request received*/
	
	DCCFileR *q=filegetStart;
	int id;
	char *nick, *newname;

	cs=(CmdStruct *)data;
	if(!cs->win) return;
	rmstr(cs->args,0);
	if(*cs->args==0) return;
	nick=alloca(sizeof(char)*strlen(cs->args));
	newname=alloca(sizeof(char)*strlen(cs->args));
	if(sscanf(cs->args,"%u %s", &id, nick)<2) return;
	if(sscanf(cs->args,"%*d %*s %s", newname)<1) newname=NULL;
	while(q!=filegetEnd)
		if(q->id==id){
			DCCFileR *p=q->next;
			char buf[512];
			sprintf(buf, "PRIVMSG %s :%cDCC SEND %s %lu %d %lu%c\r\n",
			nick, 0x01,newname?newname:q->filename, q->inetaddr, q->port, q->size, 0x01); 
			sendto_server(cs->win, buf);
			if(gflags & RM_ON_FWD){
					free(q->nick); free(q->email);free(q->filename);
					if(p==filegetEnd) filegetEnd=q;else *q=*p; free(p);
			}
			return;
		}
		else q=q->next;
	fl_addto_browser(cs->win->chanwin->brow2,
	  PROMPT"No file offer with that id");
}

static void lac_cmd(void *data){
/* chats in progress */
	
	
	DCCChatWin *p=dccchatwinStart;
	char buf[256];
	int to;
	 cs=(CmdStruct *)data;
	to=cs->win? cs->win-winstruct:-1;
	while(p!=dccchatwinEnd){
		sprintf(buf,"@f%3d. %-15s %s(%d) %u %u", p->id, p->nick, p->email?p->email:"",
		*p->fd, *p->read, *p->wrote);
		say(buf,to,1);
		p=p->next;
	}
}
static void lcrr_cmd(void *data){
/* chat reqs received */
	
	cs=(CmdStruct *)data;
  {
	ChatReqRecvd *p=chatreqStart;
	char buf[256];
	while(p!=chatreqEnd){
		sprintf(buf,"@f%3d. %-15s (%s)", p->id, p->nick, p->email);
		say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}
   }
}
static void lcrs_cmd(void *data){
/* chat reqs sent */

	cs=(CmdStruct *)data;
	{
	ChatReqSent *p=chatsentStart;
	char buf[256];
	while(p!=chatsentEnd){
		sprintf(buf,"@f%3d. %-15s (%d) %s", p->id, p->nick, 
		p->fd,ctime(&p->starttime));
		say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}
	}
}

static void lfrr_cmd(void *data){
/* waiting file offers received */

	cs=(CmdStruct *)data;
	{
	
	DCCFileR *p=filegetStart;
	char buf[256];
	while(p!=filegetEnd){
		sprintf(buf,"@f%3d. %-15.13s %s (%s) %lu %d", p->id, p->nick,p->filename, 
			p->email, p->inetaddr, p->port);
		say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}
	}
}


static void laft_cmd(void *data){
/* active file transfers */

	cs=(CmdStruct *)data;
	{
	DCCFile *p=DCCfileStart;
	char buf[256];
	while(p!=DCCfileEnd){
		struct timeval	t;
		gettimeofday(&t,NULL);
		sprintf(buf,"@f%3d. %-15.13s %s %lu %lu %ld", 
		p->id, p->nick,p->filename,p->size,
		 p->read, (long) (time(NULL)- p->starttime.tv_sec));
		 say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}
	}
}

static void lfrs_cmd(void *data){
/* waiting file offers sent */
	

	cs=(CmdStruct *)data;
	{
	
	DCCFileS *p=filesendStart;
	char buf[256];
	while(p!=filesendEnd){
		sprintf(buf,"@f%3d. %-*s %-30.28s(%d) %-20.19s", p->id,MaxNickLen, p->nick,p->filename,p->fd, ctime(&p->starttime));
		say(buf, cs->win? cs->win-winstruct:-1,1);
		p=p->next;
	}}
}
static void raft_cmd(void *data){
/* stop a file transfer*/
	int id;
	cs=(CmdStruct *)data;
	
	if(sscanf(cs->args, "%*s %u", &id)==1)
	        close_getfile(id, cs->win);
}
static void rfrr_cmd(void *data){
/* remove a file request received*/
	
	int id;
	cs=(CmdStruct *)data;
	
	if(sscanf(cs->args, "%*s %u", &id)==1){
	DCCFileR *q=filegetStart;

	filegetEnd->id=id;
	while(q->id != id)
	      q=q->next;
	if(q== filegetEnd)
	       say2(cs->win? cs->win-winstruct:-1,1,PROMPT"No such id %d",id);
	else{
		DCCFileR *p=q->next;
		free(q->nick); free(q->email);free(q->filename);
		if(p==filegetEnd) filegetEnd=q;else *q=*p; free(p);
	}
	}
}

static void rfrs_cmd(void *data){
/* remove file request sent*/
	int id;
	cs=(CmdStruct *)data;
	if(sscanf(cs->args, "%*s %u", &id)==1)
	     remove_file_offer(id);
}

static void rcrs_cmd(void *data){
/* remove a chat req u sent*/
	int id;
	cs=(CmdStruct *)data;
	if(sscanf(cs->args, "%*s %u", &id)==1)
	     remove_sentchatreq(id);
}

static void rcrr_cmd(void *data){
/* remove a chat req received*/
	int id;
	cs=(CmdStruct *)data;
	   if(sscanf(cs->args, "%*s %u", &id)==1){
	     ChatReqRecvd *q=chatreqStart;

	      chatreqEnd->id=id;
	       while(q->id!=id) q=q->next;
	      if(q==chatreqEnd)
	             say2(cs->win? cs->win-winstruct:-1,1,PROMPT"No such id %d",id);
	       else{
			ChatReqRecvd *p=q->next;
			free(q->nick); free(q->email);
			if(p==chatreqEnd) chatreqEnd=q;else *q=*p; free(p);
		}
	    }
}

static void query_cmd(void *data){

	cs=(CmdStruct *)data;
	if( !cs->win) return;
	if(!cs->win->server)
	     fl_addto_browser(cs->win->chanwin->brow2,"Not connected toa server");
	else
  {
	 char buf[255];
	 char *nick;
	 nick=nextstr(cs->args,2);
	 if(*nick==0){
		if(cs->win->query_nick){
			sprintf(buf, PROMPT"Ending conversation with %s",
			 cs->win->query_nick);
			free(cs->win->query_nick);
			cs->win->query_nick=NULL;
			if(fl_get_button(cs->win->chanwin->r_query))
				fl_set_button(cs->win->chanwin->r_quote,1);
			UpdateStatus(cs->win);
			say(buf,cs->win-winstruct,1);
		}else  say(PROMPT"You aren't querying anyone",
		cs->win-winstruct,1);
	}else{
	if(cs->win->query_nick) free(cs->win->query_nick);
	cs->win->query_nick=strdup(nick);
	fl_set_button(cs->win->chanwin->r_query,1);
	UpdateStatus(cs->win);
	sprintf(buf, PROMPT"Starting conversation with %s", nick);
	say(buf,cs->win-winstruct,1);
	}
	free(nick);
   }
}


static void msg_cmd(void *data){
/*
	/msg <nick or channnel or *> <msg>
	/notice <nick or channnel or *> <msg>
	* = current channel
*/
	char type[10];
	char *msg, *buf,*dest;
	char *fmt=NULL;
	char *to;
	int isnotice=0;

	cs=(CmdStruct *)data;
	if( !cs->win) return;
	if(!cs->win->server){
		say("No server connection", cs->win-winstruct,1);
		fl_ringbell(0);
		return;
	}
	if(gflags&DOING_NOTICE){
	  say("Notice ignored--can't reply to NOTICE!",cs->win-winstruct,1);
	  return;
	}
	to=nextstr(cs->args,2);
	if(*to==0){
		say2(cs->win-winstruct,1,"%s: RTFM",cs->args);
		free(to);
		return;
	}
	if(*to=='*' && *(to+1)==0){
	      free(to);
	      if(cs->win->chanCur==cs->win->chanStart) return;
	      else dest=strdup(cs->win->chanCur->name);
	}else{
	dest=strdup(to);
	free(to);
	}
	msg=(char *)alloca(sizeof(char)*strlen(cs->args));
	if(sscanf(cs->args, "%s %*s %[^\n]\n",type, msg) <2) return;
	uppercase2(type);
	isnotice=(type[0]!='M' || type[1]!='S' || type[2]!='G' || type[3]!=0);
	if(!isnotice && *dest=='='){
	    if (cs->win->dccCur == cs->win->dccStart) {
                if (gflags & BEEP_ERR) fl_ringbell(0);
                say2(cs->win-winstruct,1, PROMPT "No DCC connections");
		return;
	   }
           else{
	       DCCChat *chat=cs->win->dccStart->left;
	       strshift(dest,1);
	       if(*dest==0){
	          say("Missing nickname for DCC msg",cs->win-winstruct,1);
		  free(dest);return;
		}
	       while(chat!=cs->win->dccStart)
	           if(!strcasecmp(chat->nick,dest)) break;
		   else chat=chat->left;
	       if(chat==cs->win->dccStart)
		  say2(cs->win-winstruct,1, PROMPT "No DCC chat with %s",dest);
	       else{
		   fmt_string = "%n%c%h%p$";
		   buf = format_msg(fmt_you_dccchat, cs->win->server ? 
			cs->win->server->nick : Name,
			dest,
			cs->win->dccCur->email ?
			  cs->win->dccCur->email : cs->win->dccCur->nick,
			msg);
		   if (buf){
			say(buf,cs->win-winstruct,0);
			free(buf);
		   }
		  buf = (char *)malloc(sizeof(char)*(strlen(msg) + 3));
		  sprintf(buf, "%s\n", msg);
		  sendto_dcc_chat(cs->win, chat, buf);
		  free(buf);
	       }
	       free(dest);return;
	   }
	 }
	if((gflags & ENCRYPT_MSG) && (fmt=have_key(dest, ENCRYPT))){
		int ll=strlen(msg);
		char *tmp;
		encrypt_str(msg, ll, fmt);
		tmp=ctcp_quote_it(msg, ll);
		buf=(char *)malloc(sizeof(char)*(strlen(dest)+strlen(tmp)+50));
		sprintf(buf,"PRIVMSG %s :%cSED %s%c\n", dest,0x01,tmp,0x01);
		free(tmp);
		fmt=fmt_sed_your;
	}else
	if( !isnotice){
		buf=(char *)malloc(sizeof(char)*(strlen(cs->args)+50));
		sprintf(buf, "PRIVMSG %s :%s\n", dest, msg);
		if(*dest=='#' || *dest=='&') fmt= fmt_you_pub_msg;
		else fmt=fmt_you_priv_msg;
	}
	else{
		buf=(char *)malloc(sizeof(char)*(strlen(cs->args)+50));
		sprintf(buf, "NOTICE %s :%s\n", dest, msg);
		if(*dest=='#' || *dest=='&') fmt= fmt_you_pub_notice;
		else fmt=fmt_you_priv_notice;
	}
	if(*dest!='#' && *dest!='&'){
	   if(!isnotice){
		if(sflags & S_MSG) addto_sender(dest, SS_MSG);
	   }else if (sflags & S_NOTICE) addto_sender(dest, SS_NOTICE);
	}
	sendto_server(cs->win, buf);
	free(buf);
	fmt_string="%n%c%l%h%p%z$";
	sscanf(cs->args, "%*s %*s %[^\n]\n", msg);
	buf=format_msg(fmt, cs->win->server->nick,dest,Name,host,msg,strlen(msg));
	if(buf){
		say(buf,cs->win-winstruct,0);
		free(buf);
	}
       	free(dest);
}

static void nick_cmd(void *data){
	cs=(CmdStruct *)data;
	if(cs){
		char *argv[5];
		
		new_str2args(cs->args, &argc,argv,5);
		nick(argc, argv, cs->win);
	}
}

static void echo_cmd(void *data){
/* echo [[-2] txt] */

	CmdStruct *cs=(CmdStruct *)data;
	char *arg=nextstr(cs->args,2);
	int mainbrow;
	
	rmstr(cs->args,0);
	mainbrow= !(*arg=='-' && *(arg+1)=='2' && *(arg+2)==0);
	if(!mainbrow)
		 rmstr(cs->args,0);
	if(*cs->args) say(cs->args,cs->win?cs->win-winstruct:-1,!mainbrow);
	else say("echo: RTFM",cs->win?cs->win-winstruct:-1,!mainbrow);
	free(arg);
}

static void quote_cmd(void *data){
// quote string
	CmdStruct *cs=(CmdStruct *)data;
	if(!cs->win || !cs->win->server || cs->win->server->fd<0){
	   if (gflags & BEEP_ERR) fl_ringbell(0);
	   say(PROMPT"Quote: no server connection", cs->win?cs->win-winstruct:-1,1);
	   return;
	}
	else{
	  char *cmd=nextstr(cs->args,2);
	  if(*cmd==0){
	    say(PROMPT"Quote: missing arguments",cs->win-winstruct,1);
	    return;
	  }
	  if( (*cmd=='j' || *cmd=='J') && !strncasecmp(cmd+1,"oin",3)){
	        char *channame=nextstr(cs->args,3);
		if(*channame)
	           addto_cmd_sent(cs->win, "JOIN", channame);
		free(channame);
	  }
	  free(cmd);
	  cmd=(char *)alloca(sizeof(char)*(strlen(cs->args)+2));
	  sprintf(cmd,"%s\n",cs->args+find_pos(cs->args,2));
	  sendto_server(cs->win, cmd);
	}
}
static void save_window(const char *cmd)
{
}
static void quoted_cmds(void *data){
	CmdStruct *cs=(CmdStruct *)data;
	if(cs->win){
	if(!cs->win->server)
	  say(PROMPT"quote: no server connection",cs->win-winstruct,1);
	else{
		char *arg=nextstr(cs->args,1);
		uppercase2(arg);
		save_window(arg);
		arg=(char *)malloc(sizeof(char)*(strlen(cs->args)+2));
		sprintf(arg,"%s\n",cs->args);
		sendto_server(cs->win, arg);
		free(arg);
	}
    }
}
static int str2sp(const char *name){
register i, ll=strlen(name);
for (i=0;i<sp_count;i++)
	if(s_pipe[i].fd>-1 && !strncasecmp(s_pipe[i].name,name,ll))
		return i;
return -1;

}
static void server_cmd(void *data){
 
	CmdStruct *cs=(CmdStruct *)data;
	
		char *argv[12];
		
		new_str2args(cs->args, &argc,argv,12);
		server(argc, argv, cs->win);
}


static void run_cmd(void *data){
	CmdStruct *cs=(CmdStruct *)data;
	
	  char *args=alloca(sizeof(char)*strlen(cs->args));

	  if(sscanf(cs->args,"%*s %*s %[^\n]", args)<1)
	  	say("Usage: run <conenction name> <args>", cs->win? cs->win-winstruct:-1,1);
	  else {
	  char *arg=nextstr(cs->args,2);
	  launch_prog(arg,args);
	  free(arg);
	  }
	
}
static void connect_cmd(void *data){
 	/* create named connection 
	connect <name> <server> <port> <args>
	*/
	CmdStruct *cs=(CmdStruct *)data;
	
	S_Pipe *s;
	int ll=strlen(cs->args);
	char   *server=alloca(sizeof(char)*ll), *name=alloca(sizeof(char)*ll),
	 *args=alloca(sizeof(char)*ll);
	u_short port;
	if(sscanf(cs->args,"%*s %s %s %hu %[^\n]",name,server,&port,args)<3)
	{
		say2(cs->win?cs->win-winstruct:-1,1,
		"Usage: connect <connection name> <host> <port> [args]",
		nextstr(cs->args,1));
		return;
	}
	s=make_connection(name,server,port,args);
	if (s == NULL) {
		if(tcp_err_msg)
		fprintf(stderr,"%s (port %d): %s\n",server,port,tcp_err_msg);
		else
		error(-1,"Can't create %s to %s(%d)", name,server, port);
		return;
	}
     #warning todo: recheck first	
	say2(cs->win?cs->win-winstruct:-1,1,"created \"%s\" to port %hu of %s",
	 s->name,s->to.server.port,s->to.server.name);
}
static void squote_cmd(void *data){
/* quote to a name connection */
	CmdStruct *cs=(CmdStruct *)data;
	char *arg;

	arg=alloca(sizeof(char)*(strlen(cs->args)+2));
	if(sscanf(cs->args,"%*s %s",arg)<1){
	   say("Usage: squote <connection name> <args>",
	   cs->win? cs->win-winstruct:-1,1);
	    return;}
	else
   {
	int sp=str2sp(arg);
	if(sp<0)
		say2(cs->win? cs->win-winstruct:-1,1,"No such connection %s",arg);
	else{
		char *buf;
		buf=alloca(sizeof(char)*(strlen(cs->args)+2));
		if(sscanf(cs->args,"%*s %*s %[^\n]",arg)<1) return;
		sprintf(buf,"%s\n",arg);
		write_to_sp(sp,buf);
	}
    }
}


static void who_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	who(argc, argv, cs->win);
	return;
}

static void op_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	
	op(argc, argv, cs->win);
	return;
}
static void kick_cmd(void *data){
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	kick(argc, argv, cs->win);
	return;
}

static void mode_cmd(void *data){
	char *buf;
	cs=(CmdStruct *)data;
	if( !cs->win) return;
	if(!cs->win->server) return;
	buf=nextstr(cs->args,2);
	if(!*buf) {
		free(buf);
		
		buf=(char *)malloc(sizeof(char)*(strlen(cs->win->server->nick)+8));
		sprintf(buf,"MODE %s\n", cs->win->server->nick);
		sendto_server(cs->win, buf);
		free(buf);
		return;
	}else
	{
		char *mode=(char *)malloc(sizeof(char)*strlen(cs->args));
		char *nick=nextstr(cs->args,2);
		free(buf);
		buf=(char *)malloc(sizeof(char)*(strlen(cs->args)+256));
		if(sscanf(cs->args, "%*s %*s %[^\n]\n", mode)<1)
		 *mode=0;
		sprintf(buf,"MODE %s %s\n", (!(*nick=='*' && *(nick+1)==0))?nick:
	#if 1
	/* not working */ 
	cs->win->chanCur!=cs->win->chanStart?cs->win->chanCur->name:
	#endif
		  cs->win->server->nick, mode);
		if(sendto_server(cs->win, buf)==0)
		   if(!mode && (*nick=='#' || *nick=='&'))
			addto_cmd_sent(cs->win, "MODE",nick);
		free(buf);
		free(mode);
		free(nick);
	}
}
static void away_cmd(void *data){
	char *msg=NULL;
	 char mark_away=1;

	 CmdStruct *inp=(CmdStruct *)data;
	if(!inp->win) return;
	if(!inp->win->server)  return;
	msg=nextstr(inp->args,2);
	if(msg==NULL || *msg==0){
		free(msg);
		if(!(inp->win->server->flag&SET_AWAY)){
		 	msg=(char *)malloc(sizeof(char)*(strlen(away_text)+16));
			if(!msg) error(-2,"malloc error");
			sprintf(msg,"AWAY :%s\n",away_text);
			mark_away=1;
		}else{
			msg=strdup("AWAY\n");
			mark_away=0;
		}
		sendto_server(inp->win, msg);
	}else{
	free(msg);
	msg=alloca(sizeof(char)*(strlen(inp->args)+10));
	if(!msg) error(-2,"malloc error");
	sprintf(msg,"AWAY :%s\n", inp->args+find_pos(inp->args,2));
	sendto_server(inp->win, msg);
	}
}
		
static void me_cmd(void *data){
	char *buf;
	cs=(CmdStruct *)data;
	if( !cs->win) return;
	buf=nextstr(cs->args,2);
	if(*buf==0) 
	  {say(PROMPT"ME: RTFM",cs->win-winstruct,1);
	  free(buf);return;}
	else
       {
	char *dest;
	free(buf);
	if(!cs->win->server) return;
	if(fl_get_button(cs->win->chanwin->r_query) && cs->win->query_nick)
		dest=cs->win->query_nick;
	else if(cs->win->chanCur!=cs->win->chanStart)
		dest=cs->win->chanCur->name;
	else  return;/* no channels*/

	buf=(char *)malloc(sizeof(char)*(strlen(cs->args)+strlen(dest)+50));
	if(!buf) error(-2,"malloc error");
	rmstr(cs->args,0);

	sprintf(buf,"PRIVMSG %s :%cACTION %s%c\n", dest,0x01,cs->args,0x01);
	if(sendto_server(cs->win, buf)==0){
		fmt_string="%n%c%l%h%p%z$";
		free(buf);
		buf=format_msg(fmt_you_pub_action, cs->win->server->nick,
			cs->win->chanCur->name,Name,host,cs->args, strlen(cs->args));
	  	if(buf){ say(buf,cs->win-winstruct,0);free(buf);}
	}else free(buf);
  }
}
static void action_cmd(void *data){
/*
	/action <to> <msg>
	to = * means current channel

*/
	char *msg;
	
	CmdStruct *cs=(CmdStruct *)data;
	if( !cs->win) return;
	msg=nextstr(cs->args,2);
	if(!*msg){
		free(msg);
		say(PROMPT"action: RTFM",cs->win-winstruct,1);
		return;
	}
	else
  {
	char *nick,*nnick=0, *buf;

	free(msg);
	msg=(char *)alloca(sizeof(char)*strlen(cs->args));
	nnick=(char *)alloca(sizeof(char)*strlen(cs->args));
	if(sscanf(cs->args, "%*s %s %[^\n]\n", nnick,msg) < 2){
		fl_ringbell(0);
		say(PROMPT"Action <to> <msg>",cs->win-winstruct,1);
		return;
	}
	buf=(char *)malloc(sizeof(char)*(strlen(cs->args)+50));
	if(*nnick=='*' && *(nnick+1)==0)
		if (cs->win->chanCur==cs->win->chanStart){free(buf); return;}
		else nick=cs->win->chanCur->name;
	else nick=nnick;
	if(*nick!='#' && *nick!='&' && sflags & S_ACTION)
		addto_sender(nick, SS_ACTION); 
	sprintf(buf,"PRIVMSG %s :%cACTION %s%c\n", nick, 0x01,msg,0x01);
	if(sendto_server(cs->win,buf)==0){
		fmt_string="%n%c%l%h%p%z$";
		free(buf);
		buf=format_msg(fmt_you_priv_action, cs->win->server->nick,
		 nick,Name,host,msg,strlen(msg));
		if(buf){ say(buf,cs->win-winstruct,0);free(buf);}
	}
	else free(buf);
  }
}

static void chat_accept_cmd(void *data){
/* accept a chat request*/
	
	
	char *argv[5];
	

       	cs=(CmdStruct *)data ;
	new_str2args(cs->args, &argc,argv, 5);
	
	achat(argc, argv, cs->win);
	return;
}

static void chat_cmd(void *data){
/* send a chat req*/
	char *nick;
	
	cs=(CmdStruct *)data;
	if( !cs->win) return;
	nick=nextstr(cs->args,2);
	
	if(!*nick){
		say(PROMPT"chat: missing args",cs->win-winstruct,1);
		free(nick);return;
	}
       else
    {
   	int flag;
	
	free(nick);
	if(!cs->win->server){
		fl_ringbell(0);
		say(PROMPT"You are not connected to a server",cs->win-winstruct,1);
		return;
	}
	nick=(char *)alloca(sizeof(char)*strlen(cs->args));
	if(sscanf(cs->args, "%*s %s", nick) <1 ){
	      say(PROMPT"DCC chat: not enough args",cs->win-winstruct,1);
	      return;
	}else{
	char *buf=(char *)alloca(sizeof(char)*(strlen(nick)+64));
	if(sscanf(cs->args,"%*s %*s %d", &flag)<1) flag=0;
	if(dcc_sendchatreq(cs->win, flag?NULL: cs->win, nick)){
		sprintf(buf, PROMPT"DCC chat connection to %s failed",nick);
		say(buf,cs->win-winstruct,1);
	}else{
		sprintf(buf, PROMPT"DCC chat request sent to %s",nick);
		say(buf,cs->win-winstruct,1);
	}
    }
  }
}
static void chat_close_cmd(void *data){
/* close a chat session */
	char *reason;
	
	
	cs=(CmdStruct *)data;
	if( !cs->win) return;

	reason=nextstr(cs->args,2);
	if(!*reason){
		say(PROMPT"close dcc: RTFM",cs->win-winstruct,1);
		free(reason);return;
	}
	else
  {
	DCCChatWin *q=dccchatwinStart;
	int id;
	id=atoi(reason);
	free(reason);
	if(id)
		while(q!=dccchatwinEnd) if(q->id==id) break; else q=q->next;
	else{
		size_t ll=strlen(reason); 
		while(q!=dccchatwinEnd) 
			if(!strncasecmp(reason, q->nick, ll)) { id=q->id; break;}
			else q=q->next;
	}
	if(q==dccchatwinEnd)
		say(PROMPT"No chat with that id/person",cs->win-winstruct,1);
	else{
	   reason=alloca(sizeof(char)*strlen(cs->args));
	/*if(sscanf(cs->args, "%*s %d", &id)<1) return;*/
	   if(sscanf(cs->args, "%*s %*s %[^\n]\n",  reason)<1) 
		reason=NULL;
	   if(!remove_dccchat(id, reason))
		say(PROMPT"No dcc chat with that id to close",cs->win-winstruct,1);
	   else{
	       UpdateStatus(cs->win);
	       say(PROMPT"DCC chat closed.",cs->win-winstruct,1);
	   }
	}
  }
}


static void get_cmd(void *data){
/* receive a file*/
	
	char *argv[5];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, 5);
	
	get(argc, argv, cs->win);

	return;
}
static void send_cmd(void *data){
/* offer file to someone*/
	
	char *argv[MAXARGC];
	

       	cs=(CmdStruct *)data ;
	if( !cs->win) return;
	new_str2args(cs->args, &argc,argv, MAXARGC);
	
	offer(argc, argv, cs->win);
	return;
}


/****************************************************************/
/*	c t c p							*/
/****************************************************************/

static void ping_cmd(void *data){
/* /ping nikc1 nick2,nick3 ... */
	char *buf;
	
	cs=(CmdStruct *)data;
	
	if( !cs->win) return;
  if(!cs->win->server) return;

	buf=(char *)malloc(sizeof(char)*strlen(cs->args));
	if (sscanf(cs->args,"%*s %[^\n]\n", buf)<1) return;
#warning REMOVE: not strtok!
	buf=strtok(buf,", \t");
	while(buf){
		char s[128];
		struct timeval t;

		if(gettimeofday(&t, NULL)!=EINVAL)
		   sprintf(s,"PRIVMSG %s :%cPING %d %d%c\n",
		   buf,0x01,t.tv_sec, t.tv_usec,0x01);
		else sprintf(s,"PRIVMSG %s :%cPING %ld%c\n",
		   buf,0x01,time(NULL),0x01);
		sendto_server(cs->win,s);
		
	  	buf=strtok(NULL,", \t");
	}
}

#if 1
/*################################
/dcc bla bla bla. too lazy to do it . use chat,send etc
##################################*/


static void list_dcc(int to){


	DCCChatWin *p=dccchatwinStart;
	ChatReqRecvd *p2=chatreqStart;
	ChatReqSent *p3=chatsentStart;
	DCCFileS *p6=filesendStart;
	DCCFileR *p4=filegetStart;
	DCCFile *p5=DCCfileStart;
	char buf[512];

  /* dcc chat connections in progress */
	while(p!=dccchatwinEnd){
		sprintf(buf,"@f%3d. %-15s %s(%d) %u %u", p->id, p->nick, p->email?p->email:"",
		*p->fd, *p->read,*p->wrote);
		say(buf,to,0); 		
		p=p->next;
	}
/* chat reqs received */
	while(p2!=chatreqEnd){
		sprintf(buf,"@f%3d. %-15s (%s)", p2->id, p2->nick, p2->email);
		say(buf,to,0);
		p2=p2->next;
	}
/* chat reqs sent */
	
	while(p3!=chatsentEnd){
		sprintf(buf,"@f%3d. %-15s (%d) %s", p3->id, p3->nick, 
		p3->fd,ctime(&p3->starttime));
		say(buf,to,0);
		p3=p3->next;
	}

/* waiting file offers received */
	
	while(p4!=filegetEnd){
		sprintf(buf,"@f%3d. %-15.13s %s (%s) %lu %d", p4->id, p4->nick,
		p4->filename, 
			p4->email, p4->inetaddr, p4->port);
		say(buf,to,0); 
		p4=p4->next;
	}

/* active file transfers */

	
	while(p5!=DCCfileEnd){
		struct timeval	t;
		gettimeofday(&t,NULL);
		sprintf(buf,"@f%3d. %-15.13s %s %lu %lu %ld", 
		p5->id, p5->nick,p5->filename,p5->size,
		 p5->read, (long) (time(NULL)- p5->starttime.tv_sec));
		say(buf,to,0); 
		p5=p5->next;
	}

/* waiting file offers sent */
	while(p6!=filesendEnd){
		sprintf(buf,"@f%3d. %-*s %-30.28s(%d) %-20.19s", 
		p6->id,MaxNickLen, p6->nick,p6->filename,p6->fd,
		 ctime(&p6->starttime));
		say(buf,to,0); 
		p6=p6->next;
	}
	return;
}



typedef struct TDCCCmdType{
	int cmd;
	char *name;
} DCCCmdType;
#define dcc_CHAT	(0)
#define dcc_CLOSE 	(1)
#define dcc_GET		(2)
#define dcc_LIST	(3)
#define dcc_SEND	(4)

static int lookup_dcc_cmd(const char *name){
	DCCCmdType cmds[]={
		{dcc_CHAT, "CHAT"},
		{dcc_CLOSE,"CLOSE"},
		{dcc_GET, "GET"},
		{dcc_LIST,"LIST"},
		{dcc_SEND,"SEND"}
	};
	DCCCmdType *p=cmds;
         register int low, high, mid, cond;

         low = 0; high = sizeof(cmds)/sizeof(DCCCmdType) - 1;
         while (low <= high) {
         	mid = (low + high) / 2;
         	if ((cond = strcasecmp(name,(p + mid)->name)) < 0)
         	high = mid - 1;
         	else if (cond > 0) low = mid + 1;
         	else  return (p + mid)->cmd;
         }
         return -1;
}

static void dcc_cmd(void *data){
	
	char *cmd;

	cs=(CmdStruct *)data;
	cmd=nextstr(cs->args,2);
	if(!*cmd) {
	    free(cmd); list_dcc(cs->win?cs->win-winstruct:-1);
	    return;
	 } /* /dcc */
    else {
	int i;

	i= lookup_dcc_cmd(cmd);
	if(i<0){
		say2(cs->win?cs->win-winstruct:-1,1,
		    PROMPT"Unknown DCC command: %s",cmd);
		return;
	}
	switch(i){
		case dcc_CHAT:/* dcc chat nick */
		case dcc_SEND:
		case dcc_GET:
		{
			rmstr(cs->args,0);
			new_process_cmd(cs->args,cs->win?cs->win-winstruct:-1);
			break;
		}
		case dcc_CLOSE: break;/* dcc close get nick */
		case dcc_LIST: list_dcc(cs->win? cs->win-winstruct:-1);break;
	}
 }

}

#endif

static int str_lookup(const char **p, const char *var, int n);
static void std_ctcp(void *data){
/* e.g.:	/finger nick1 nick2 nick3 ... */
	const char 	*std_ctcp_cmd[]={
		"CHELP",
		"CLIENTINFO",
		"FINGER",
		"HELP",
		"TIME",
		"USERINFO",
		"VERSION",
		
	};
	char *nick;
	

	cs=(CmdStruct *)data;
	if(!cs->win ) return;
	nick=nextstr(cs->args,2);
	if(!*nick) {
		fl_ringbell(0);
		say(PROMPT"Missing nickname(s)",cs->win? cs->win-winstruct:-1,1);
		free(nick);
		return;
	}
   else {
	const char **p=std_ctcp_cmd;
	 char *cmd;
	 int i;
	 free(nick);
	cmd=nextstr(cs->args,1);
	i=str_lookup(p, cmd, sizeof(std_ctcp_cmd)/sizeof(char *) );
	if(i<0){
		say2(cs->win? cs->win-winstruct:-1, 1,
		PROMPT"%s: Unknown CTCP cmd",cmd);
		free(cmd);return;
	}else{
		int error=0;
		free(cmd);
		if(!strcasecmp("chelp", std_ctcp_cmd[i])) cmd="HELP";
		else cmd=(char *)std_ctcp_cmd[i];
		nick=strtok(cs->args,", \t");
		while( (nick=strtok(NULL,", \t")) && !error){
			char s[128];
			sprintf(s,"PRIVMSG %s :%c%s%c\n", nick,0x01,cmd,0x01);
			error=sendto_server(cs->win,s);
		} 
	}
  }
}
static int str_lookup(const char **p, const char *var, int n){
	register int low, high, mid, cond;
	low=0; high=n-1;
	while(low<=high){
		mid=(low+high)/2;
		if( (cond=strcasecmp(var, *(p+mid)) )<0 )
			high=mid-1;
		else if(cond>0)
			low=mid+1;
		else
			return mid;
	}
	return -1;
}


static void other_ctcp(void *data){
/*
	/ctcp nick args
	default args="VERSION"
	/reply nick usersinfo bang bang!
*/
	
       char *nick;	
	cs=(CmdStruct *)data;

	if(!cs->win) return;
	nick=nextstr(cs->args,2);
	if(*nick==0) {
		say(PROMPT"CTCP: RTFM", cs->win-winstruct,1);
		free(nick);
	}
else{
	char *buf;
	char *bigbuf=NULL;
	if(!cs->win->server){
		fl_ringbell(0);
		say(PROMPT"No server",cs->win-winstruct,1);
	 	return;
	}
	buf=(char *)malloc(sizeof(char)*(strlen(cs->args)));
	if (sscanf(cs->args,"%*s %*s %[^\n]\n",buf)<1)
		{free(buf);buf=strdup("VERSION");}
	bigbuf=(char *)malloc(sizeof(char)*(strlen(cs->args)+64));
	if(!strncasecmp(cs->args,"reply ",6)){
		#define MAX_SERV_SEND	400/*485*/
			sprintf(bigbuf,"NOTICE %s :%c%s%c\n", nick,0x01,buf,0x01);
			if(strlen(bigbuf)>MAX_SERV_SEND){
			 *(bigbuf+MAX_SERV_SEND-2)=0x01;
			 *(bigbuf+MAX_SERV_SEND-1)='\n';
			*(bigbuf+MAX_SERV_SEND)='\0';
			 }
			 sendto_server(cs->win, bigbuf);
	}
	else 
	       if(*nick=='*' && nick[1]==0)
		  if(cs->win->chanCur!=cs->win->chanStart){
		  	User *p=cs->win->chanCur->userStart;
			while(p!=cs->win->chanCur->userEnd){
				sprintf(bigbuf,"PRIVMSG %s :%c%s%c\n",
				 p->name,0x01,buf,0x01);
				 sendto_server(cs->win, bigbuf);
				 p=p->next;
			}
		   }else fl_addto_browser(cs->win->chanwin->brow2,
			PROMPT"*: No channels");
		else {
			sprintf(bigbuf,"PRIVMSG %s :%c%s%c\n", nick,0x01,buf,0x01);
			sendto_server(cs->win, bigbuf);
		}
	free(bigbuf); free(nick);
  }
}


extern void add_cmdoncon(int type, char *cmd, char *server, u_short port){
/* command to execute on connection to server*/
	CmdOnCon *p;

	if(!cmd) return;
	p=cmdonconStart;
	cmdonconStart=(CmdOnCon *)malloc(sizeof(CmdOnCon));
	if(!cmdonconStart){error(-2,"malloc error"); return;}
	cmdonconStart->type=type;
	cmdonconStart->cmd=strdup(cmd);
	cmdonconStart->server=strdup2(server);	/* NULL-->any server */
	cmdonconStart->port=port;		/* <1-->any port */
	cmdonconStart->next=p;
	return;
}
static void lnicks_cmd(void *data){
	 int n=0;
	 while(n<iNickListCount){
	 	if(aNickList[n].label){
			 Nicks *p=aNickList[n].start->left;
			 
			 fprintf(stdout,"\E[4m%s\E[m:\n",aNickList[n].label);
			 while(p!=aNickList[n].start){
			 	fprintf(stdout,"\t%s%s\n",
				p==aNickList[n].current?"*":"",
				p->nick	);
				p=p->left;
			}
	 	}
	 	n++;
	 }
}

static void lastlog_cmd(void *data){
   // lastlog expr file
   char *args=alloca(strlen(cs->args)*sizeof(char));
   cs=(CmdStruct *)data;
   if(sscanf(cs->args,"%*s %[^\n]\n", args)<1)
        say("Usage: lastlog [ -[[AB] ]num ] [ -[CEFGVBchilnsvwx] ] [ -e ] <pattern>",
	     cs->win?cs->win-winstruct:-1,1);
   else{
	char *buf=malloc((8+strlen(cs->args)+strlen(log_file))*(sizeof(char)));
	if((sflags&LOG)==0 && (gflags&VERBOSE_CLIENT))
	     say("logging is off; using old log",cs->win?cs->win-winstruct:-1,1);
	sprintf(buf,"grep %s \"%s\"",args,log_file);
	fl_exe_command(buf, 0);
	fl_show_command_log(FL_FULLBORDER);
	free(buf);
   }
}
#ifdef _GUILE
static void load_cmd(void *data){
// same as (load)m but expands tilde ~
	char *name;
	cs=(CmdStruct *)data;

	name=nextstr(cs->args,2);
	if(!*name){
		say(PROMPT"load: missing file name",cs->win?cs->win-winstruct:-1,1);
		free(name);
	}else{
	   if(*name=='~'){
	      	 char *file=expand_tilde(name);
		 if(file){
		   free(name);
		   name= strdup(file);
		   free(file);
		 }
	   }
	  if(access(name, R_OK)==-1)
	       say2(cs->win?cs->win-winstruct:-1,1,
	           "load: Can't access %s: %s",name,strerror(errno));
	  else
	       gh_eval_file_with_catch(name,&exception_handler);
	 free(name);
	}
	
}
#endif

static void list_flood(Flood *p,int w){
	if(p){
		list_flood(p->left,w);
		say2(w,0,"- %s\t%d at %lu",p->from, p->count, p->at);
		list_flood(p->right,w);
	}
}

static void flood_print_cmd(void *data){
int w;
cs=(CmdStruct *)data;
w=cs->win? cs->win-winstruct:-1;
say("priv Flood list:",w,0);
list_flood(floodTree,w);
say("pub Flood list:",w,0);
list_flood(publicfloodTree,w);
}

static void alarm_cmd(void *data){
   char *args;
   cs=(CmdStruct *)data;
   args=nextstr(cs->args,2);
   
   if(*args=='-' && !strncasecmp(args,"-del", 4)){
      char *refs=nextstr(cs->args,3);
      int ref;
      if(*refs==0 || sscanf(refs,"%d",&ref)<1){
           if(gflags & BEEP_ERR) fl_ringbell(0);
	   say(PROMPT"Usage: alarm -del <ref>",cs->win?cs->win-winstruct:-1,1);
	   }
	else
	    del_alarm(ref,ALARM_IN);
	free(refs);free(args);
	return;
  }else
  {
   Timer t;
   int sec;
   
   free(args);
   t.cmd.cmd=malloc(sizeof(char)*strlen(cs->args));
   if(sscanf(cs->args,"%*s %d %d %[^\n]\n", &t.ref,&sec,t.cmd.cmd)<3
    || sec<0){
       if(gflags & BEEP_ERR) fl_ringbell(0);
       say(PROMPT"Usage: alarm <numeric ID> <seconds> <action>",cs->win?
       cs->win-winstruct:-1,1);
   }else{
     t.type=ALARM_IN;
     t.flag=TIMER_ALARM;
     if(add_timer(&t, (void *)&sec)==-1) error(-2,"malloc error");
   }
   free(t.cmd.cmd);
   }
}

#define CLOCK_USAGE(n) {if(gflags & BEEP_ERR) fl_ringbell(0);\
    say(PROMPT"Usage: clock [-ref <id>] <HH:MM:SS-DD:mm:YYYY> <action>",(n),1);\
    }
static void clock_cmd(void *data)
{
char *args;
   cs=(CmdStruct *)data;
   args=nextstr(cs->args,2);
   if(*args==0) {free(args);return;}
   if(*args=='-' && !strncasecmp(args,"-del", 4)){
      char *refs=nextstr(cs->args,3);
      int ref;
      if(*refs==0 || sscanf(refs,"%d",&ref)<1)
            CLOCK_USAGE(cs->win?cs->win-winstruct:-1)
       	else
	    del_clock(ref, ALARM_IN);
	free(refs);free(args);
	return;
  }else
  {
   Timer t;
   struct tm *when;
   time_t now;
   int year,mon;
   int ref=0;
   int start=0;

   if(*args=='-' && !strncasecmp(args,"-ref", 4)){
      char *refs=nextstr(cs->args,3);
      int ref;
      if(*refs==0 || sscanf(refs,"%d",&ref)<1){
          free(refs);free(args);
      	  CLOCK_USAGE(cs->win?cs->win-winstruct:-1)
	  return;
	  }
	   free(refs);
	   start=find_pos(cs->args,1);
	   args=nextstr(cs->args,4);
   }
   t.cmd.cmd=malloc(sizeof(char)*strlen(cs->args));
   now=time(NULL);
   when=localtime(&now);
   when->tm_sec=0;
   year=1900+when->tm_year;
   mon=when->tm_mon+1;
   if(sscanf(args, "%d:%d:%d-%d.%d.%d", &when->tm_hour,&when->tm_min,
       &when->tm_sec, &when->tm_mday, &mon, &year)<2
       ||
       sscanf(cs->args+start,"%*s %*s %[^\n]\n", t.cmd.cmd)<1)
       CLOCK_USAGE(cs->win?cs->win-winstruct:-1)
   else{
     if(year<when->tm_year+1900){
          fl_ringbell(0);
	  fprintf(stderr, "clock- Invalid year given: %d\n", year);
	  free(t.cmd.cmd);free(args);return;
     }
     when->tm_year=year-1900;
     when->tm_mon=mon+1;
     t.ref=ref;
     t.type=ALARM_IN;
     t.flag=TIMER_CLOCK;
     if(add_timer(&t,(void *)when)==-1) error(-2,"malloc error");
   }
   free(t.cmd.cmd);
   }
   free(args);
}

/*	s t o p	       s t o p		s t o p		s t o p			*/

/************************************************/
/*	cmd handling routines			*/
/************************************************/

int     AddToHistory(const char *s)
{
	History *p;
	//assert(s && *s);
	p = (History *) malloc(sizeof(History));
	if (p == NULL)
		return -2;
	p->line = strdup(s);
	p->left = histCur;
	p->right = histCur->right;
	histCur->right->left = p;
	histCur->right = p;

	return 0;
#if 0
	History *current;
	HistSize += sizeof(s);
	current = histStart->right;
	while (HistSize > MAX_HIST_SIZE && current != histStart) {
		/* remove 1 command from the top of list .. jeez tere's no top, u dummy */
		History *next;

		if (current == histStart)
			return;	/*list is empty */
		next = current->right;
		HistSize -= sizeof(current->line);
		free(current->line);
		current->left->right = next;
		next->left = current->left;
		free(current);
		current = next;
	}
	return 0;
#endif
}
int parse_input(int i, const char *inp, int log)
{
	char   *str, *buf;
	
	str = (char *) inp;
	if (*str==0)
		return 0;
	if(!win_invalid(i) && log && (gflags & HISTORY) && (!AddToHistory(str)))
	    winstruct[i].chanwin->cmd_fwd->u_ldata = (long) 0L;
	if (*str != cmdchar || (*str == cmdchar && *(str + 1) == cmdchar)) {
		/* either  "text" or "//text" */
	  if (*str == cmdchar)
	  	str++;
	  if(!win_invalid(i))
	  {
		Winstruct *win=&winstruct[i];
		if (fl_get_button(win->chanwin->r_quote)) {
		#if defined _GUILE
			parse_scheme(str, i);
			return 0;
		#else
			char   *c, *t=NULL;

			if(*str!=0 && isspace(*str))
	                     unspace(str);
	                if(*str==0) return 0;
			if (!strncasecmp(str, "join", 4)) {	/*use by parse_server_output */
				c = nextstr(str, 2);
				if (on_channel(win->server, c)) {
					say2(i,1, 
					PROMPT "already on channel %s",c);
					return 0;
				}
				t = "JOIN";
				free(c);
			}
			else if (!strncasecmp(str, "mode", 4))	/*used by RPL_CHANNELMODEIS alone */
				t = "MODE";
			else if (!strncasecmp(str, "names", 5))
				t = "NAMES";
			if (t) {
				c = nextstr(str, 2);
				if (!strncasecmp(str, "names", 5))
					addto_cmd_sent(win, t, NULL);
				else if (c && (*c == '#' || *c == '&'))
					addto_cmd_sent(win, t, c);
				free(c);
			}
			buf = (char *)alloca(sizeof(char)*(strlen(str) + 3));
			sprintf(buf, "%s\n", str);
			sendto_server(win, buf);
			return 0;
		#endif
		}
		else if (fl_get_button(win->chanwin->r_dcc_chat)) {
			if (win->dccCur == win->dccStart) {
				if (gflags & BEEP_ERR) fl_ringbell(0);
				fl_addto_browser(win->chanwin->brow2, PROMPT "No DCC connection");
			}
			else {
				char *buff;
				fmt_string = "%n%c%h%p$";
				buff = format_msg(fmt_you_dccchat, win->server ? 
				win->server->nick : Name, win->dccCur->nick,
				win->dccCur->email ? win->dccCur->email : win->dccCur->nick,
				str);
				if (buff){
					say(buff,i,0);
				        free(buff);
				}
				buff = (char *)malloc(sizeof(char)*(strlen(str) + 3));
				sprintf(buff, "%s\n", str);
				sendto_dcc_chat(win, win->dccCur, buff);
				free(buff);
			}
			return 0;
		}
		else
		if(fl_get_button(win->chanwin->r_echo)) {
			say(str,i,0);
			return 0;
		}
		else {
			char   *cmd = NULL, *dest=0;

			if (fl_get_button(win->chanwin->type)) {
				cmd = (char *) fl_get_choice_text(win->chanwin->action);
				if (!cmd || *cmd==0) {
					if (gflags & BEEP_ERR) fl_ringbell(0);
					fl_addto_browser(win->chanwin->brow2, 
					PROMPT "No cmd to send (bug?)");
					return -1;
				}
			}
			if (fl_get_button(win->chanwin->r_query))
				if (win->query_nick)
					dest = win->query_nick;
				else {
					if (gflags & BEEP_ERR) fl_ringbell(0);
					fl_addto_browser(win->chanwin->brow2, 
					PROMPT "No nick to query!");
					return 0;
				}
			else if (fl_get_button(win->chanwin->r_channel))
				if (win->chanCur == win->chanStart) {
					if (gflags & BEEP_ERR) fl_ringbell(0);
					fl_addto_browser(win->chanwin->brow2, 
					PROMPT "Not yet on any channel");
					return -1;
				}
				else
					dest = win->chanCur->name;
			if (!cmd)
				cmd = "msg";
			buf = alloca(sizeof(char)* (strlen(str) + 
			strlen(cmd) + strlen(dest) + 4));
			sprintf(buf, "%s %s %s", cmd, dest, str);
			str = buf;
		}
	   }/* !win_invalid(i) */
	   else
	   {
	       say(str,-1,1); return 0;
	      /*if(*str!=0 && isspace(*str))
	            unspace(str);
	      if(*str==0) return 0; */
	      }
	} 
	else{
	      if(*++str!=0 && isspace(*str))
	            unspace(str);
	      if(*str==0)
	                return 0;
	      }
	if(*str=='!'){
		buf=alloca(sizeof(char)*(strlen(str) + 3));
		sprintf(buf,"! %s", ++str);
		str=buf;
	}
	if (new_process_cmd(str, i)) {
		char *cc=nextstr(str, 1);
		say2(i,1, PROMPT "%s: command not found", cc);
		if (gflags & BEEP_ERR) fl_ringbell(0);
		free(cc);
	}
	return 0;
}

extern int load_bi_cmds(void){
/*load built-in cmds*/
typedef struct TBiCmd{
	char *name;
	char *help;
	void (*func)(void *);
} BiCmd;
BiCmd	built_in_cmds[]={
	{"whatis",	"display brief description of a command",& whatis_cmd},
	{"apropos",	"search whatis list for strings", &apropos_cmd},
	{"ignore",	"specify what to ignore from names users./ig -help",&ignore_cmd},
	{"set",		"change client setting",& set_cmd},
	{"history",	"manipulate the command history list",&history_cmd},
	
	{"lch",		"list channels on current window", &lch_cmd},
	{"lg",		"list all your irc channels", &lg_cmd},
	{"lu",		"list members of current channel", &lu_cmd},
	{"fwdcr",	"forward chat request", &fwdcr_cmd},
	{"fwdfr",	"forward file request", &fwdfr_cmd},
	{"lac",		"list active chats", &lac_cmd},
	{"lcrr",      	"list chat reqs recvd", &lcrr_cmd},
	{"lcrs",      	"list chat reqs sent", &lcrs_cmd},
	{"lfrs",      	"list file reqs sent", &lfrs_cmd},
	{"lfrr",      	"list file reqs recvd", &lfrr_cmd},
	{"laft",      	"list active file transfers", &laft_cmd},
	{"fclose",	"stop an active file transfer", &raft_cmd},
	{"rfrs",      	"remove file request sent", &rfrs_cmd},
	{"rfrr",      	"rm file request received", &rfrr_cmd},
	{"rcrs",      	"remove chat request sent", &rcrs_cmd},
	{"rcrr",      	"rm chat request received", &rcrr_cmd},
	{"server",	"manipulate server list or change server", &server_cmd},
	{"send",      	"offer files to somebody",&send_cmd}, 
	{"cclose",	"close a DCC chat connection", &chat_close_cmd},
	{"get",		"accept a file", &get_cmd},
       	{"chat",      	"create a DCC chat connection",&chat_cmd},
	{"achat",	"accept a DCC chat request",&chat_accept_cmd},
	{"ping",       	"send the std un*x time to multiple recipients",&ping_cmd},
	{"query",	"start a private conversation", &query_cmd},
	{"msg",		"send a message to a channel or to somebody", &msg_cmd},
	{"notice",	"send a notice to a channel or to person", &msg_cmd},
	{"nick"	,	"change your nickname", &nick_cmd},
	{"help"	,	"show help on a command", &help_cmd},
	{"me",		"send a CTCP ACTION to a channel", &me_cmd},
	{"action",	"send a CTCP ACTION to a person or channel", &action_cmd},
	{"ctcp",       	"send a CTCP command",&other_ctcp},
	{"reply",      	"manually reply to a CTCP command",&other_ctcp}, 
	{"encrypt",	"handle encrypted messages", encrypt_cmd},
	{"clientinfo",	"send a CTCP CLIENTINFO to multiple recipients",&std_ctcp},
	{"finger",	"send a CTCP FINGER to multiple recipients",&std_ctcp},
	{"chelp",	"send a CTCP HELP to multiple recipients",&std_ctcp},
	{"time",	"send a CTCP TIME to multiple recipients",&std_ctcp}, 
	{"userinfo",	"send a CTCP USERINFO to multiple recipients",&std_ctcp}, 
	{"version",	"send a CTCP VERSION to multiple recipients",&std_ctcp}, 
	
	{"quote",	"quote a command to server", &quote_cmd},
	{"who",		"list users on irc or upate internal channel user list", &who_cmd},
	{"whois",	"request info about persons using named nicknames", &quoted_cmds},
	
	{"on",		"preliminary hook structure..testing",&on_cmd},
	{":",		"empty command. Has no effect.",&empty_cmd},
	{"window",	"operations on channel window objects",&window_cmd},
	{"bell",	"ring the keyboard bell", &bell_cmd},
	
	{"whowas",	"request info about persons who used the nicknames",&quoted_cmds},
	{"userhost",	"ask for information about named persons",&quoted_cmds},
	{"ison",	"chack if named persons are currently on irc",&quoted_cmds},
	{"note",	"something to do with NOTE service",  &quoted_cmds},
	{"away",	"(un)mark yourself as being away", &away_cmd}, 
	{"mode",	"change user or channel mode", &mode_cmd},
	{"op",		"make people operators on current channel; channel MODE",&op_cmd},
	{"kick",	"eject somebody from a channel", &kick_cmd},
	{"invite",	"invite someone to a channel", &invite_cmd},
	{"deop",	"just that; channel MODE ",&op_cmd},
	{"topic",	"change channel topic",topic_cmd},
	{"leave",	"leave a channel (equivalent to part)",part_cmd},
	{"part",	"leave a channel",part_cmd},
	{"join",	"join channels", &join_cmd},
	{"!",		"run a shell command",&shell_cmd},
	{"lag",		"force lag update", &lag_cmd},
	{"echo",	"echo a text", &echo_cmd},
	{"bugs",	"list known bugs", &warranty_cmd},
	{"warranty",	"bugs and warranty info", &warranty_cmd},
	{"quit",	"quit IRC session on a server", &quit_cmd},
	{"exit",	"quit irc and end application", &exit_cmd},

	{"dcc",		"DCC commands",&dcc_cmd},

	{"ln",	"-debug- list nickname groups to stdout", &lnicks_cmd},
	{"connect","create a named server connection", &connect_cmd},
	{"run","create a named file connection",&run_cmd},
	{"squote","quote to a named connection",&squote_cmd},
	{"lastlog","grep output log. see grep(1)",&lastlog_cmd},
	{"fprint", "-debug- print flood list",&flood_print_cmd},
	{"alarm", "set an alarm. please use (gs-alarm)",&alarm_cmd},
	{"clock", "set a clock. please use (gs-clock)",&clock_cmd},
	#ifdef _GUILE
	{"load",	"load a Guile script:/load filename", &load_cmd},
	#endif
	};	

	Cmd cmd;
	int nvars=sizeof(built_in_cmds)/sizeof(BiCmd);
       int i;

       for(i=0;i<nvars;i++){
	       	cmd.name=built_in_cmds[i].name;
		cmd.help=built_in_cmds[i].help;
		cmd.type=CMD_IN|CMD_NORMAL;
		cmd.cmd.in=built_in_cmds[i].func;
		insert_cmd(&cmd);
	}
	return 0;

}
extern int new_process_cmd(const char *str, int i){
/* str may be trashed after this call */
	

	#if defined _GUILE
	 if(*str=='(')
	       return (0-parse_scheme(str,i));
	else
	#endif
 {
	Cmd *cmd;
	char *buf=nextstr(str,1);
	cmd=find_cmd(buf,0);
	free(buf);
if(!cmd)
        return (-1);
else{
	Winstruct *win;
	if(win_invalid(i))
		win=NULL;
	else win=&winstruct[i];

	if(cmd->type & CMD_IN){
		CmdStruct cs;
		char *tt=strdup(str);
		rmstr((char*)tt,0);
		if(*tt==0)
			cs.args=strdup(cmd->name);
		else{
		cs.args=(char *)malloc(sizeof(char)*(
		    8+strlen(tt)+strlen(cmd->name)));
		  sprintf(cs.args, "%s %s", cmd->name, tt);
		}
		cs.win=win;
       		(cmd->cmd.in)( (void*)&cs);
		free(cs.args);
		free(tt);
	}
	 else	if(cmd->type & CMD_FD){
			char port[8];
			char   *name;

			if(win && win->server && win->server->fd>-1){ 
				name=win->server->name?win->server->name:win->server->servname;
				sprintf(port,"%hu",win->server->port);
			}else{ name=""; port[0]='\0';}
			buf = (char *) alloca(sizeof(char) * (strlen(str) +MAXCMDLEN+ 64 +strlen(name)));
			if(buf==NULL) return 0;
			rmstr((char*)str,0);
			/* <id> <cmd> <server,port> <rest> */
			if(*str)
			   sprintf(buf,"%d %s %s,%s %s\n", i, cmd->name, name, port,str);
			else
			   sprintf(buf,"%d %s %s,%s\n", i, cmd->name, name, port);
			write_to_sp(cmd->cmd.sp, buf);
			return 0;
		} 
	#ifdef _GUILE 
	else if(cmd->type & CMD_SCM){
		#define DAT_SIZE 64
		char data[DAT_SIZE+1];
		Scm_cmd_arg args;

		args.func=cmd->cmd.scm;
		args.args=gh_list(gh_str02scm ((char *) str),
		                gh_long2scm(i),
				SCM_UNDEFINED);
		if(snprintf(data,DAT_SIZE,"Was processing \"%s\"",(char *)str)==-1)
		  {data[DAT_SIZE]=0;
	             strcpy(&data[DAT_SIZE-4],"...\"");
                   }
		gh_catch(SCM_BOOL_T, &call_scm_command, &args,
		 (scm_catch_handler_t)&exception_handler, (void *)&data);
	}
	#endif
	else {
		say2(-1,1,"unknown cmd type %#x", cmd->type);
		return (-1);
		}
	return 0;
 }  }
}

extern Cmd *_find_cmd(char *name, int type, int use_fullname){
	Cmd *p;
	int c;
	assert( type==CMD_CTCP || type==CMD_NORMAL);
	p= type==CMD_CTCP? ctcp_cmdTree : cmdTree; 
	while(p){
		c= strcasecmp(name, p->name);
		if(c==0)
		    return p;
		else 
		   if(c<0) p=p->left;
		else p=p->right;
	}
	if(!use_fullname){
	   size_t ll;
	   ll=strlen(name);
	   p= type==CMD_CTCP? ctcp_cmdTree : cmdTree;
	   while(p){
	        c= strncasecmp(name, p->name,ll);
		if(c==0)
			return p;
		else 
		if(c<0) p=p->left;
		else p=p->right;
	   }
	}
	return NULL;
} 


extern int _remove_cmd(char *name,int type){
// type is either CMD_NORMAL or CMD_CTCP
	Cmd *c;
	static int del_cmd(pCmd *pp, Cmd *c,int *count);
	c=_find_cmd(name, type,1);
	if(!c) return -1;
	else{
		if(type==CMD_CTCP)
		  del_cmd(&ctcp_cmdTree, c,&no_of_ctcp_cmds);
		 else
		    del_cmd(&cmdTree, c,&no_of_cmds);
	}
	return 0;
}



static void left_rotate(pCmd	*pp){
	pCmd	p=*pp, r;
	*pp= r = p->right;
	p->right = r->left;
	r->left=p;
	p->bf--;
	if(r->bf>0) p->bf -= r->bf;
	r->bf--;
	if(p->bf<0) r->bf += p->bf;
}

static void right_rotate(pCmd *pp){
	pCmd	p=*pp, l;
	*pp= l = p->left;
	p->left = l->right;
	l->right=p;
	p->bf++;
	if(l->bf<0) p->bf -= l->bf;
	l->bf++;
	if(p->bf>0) l->bf += p->bf;
}

extern int _insert_cmd(pCmd *pp, Cmd *c, int *count){
	int dH=0;
	pCmd p=*pp;
	int tt;
	
	assert(c && c->name);
	if(p==NULL){
		
		*pp=p=(pCmd)malloc(sizeof(Cmd));
		if(!p) error(-2,"malloc error");
		p->name=strdup(c->name);
		p->help=strdup2(c->help);
		p->type=c->type;
		p->cmd=c->cmd;
		p->bf=0;
		p->left=p->right=NULL;
		dH=1;
		(*count)++;
	}else
	if( 
	    (tt=strcasecmp( c->name, p->name)) >0  
	  ){
	   if(_insert_cmd(&p->right, c, count)){
		p->bf++; 	
		if(p->bf==1) dH=1; else
		if(p->bf==2){
			if(p->right->bf==-1) right_rotate(&p->right);
			left_rotate(pp);
		}
	   }
	}else
	if( 
	   tt<0
	  ){
	   if(_insert_cmd(&p->left, c, count)){
	   	p->bf--;
		if(p->bf==-1) dH=1;else
		if(p->bf==-2){
			if(p->left->bf==1) left_rotate(&p->left);
			right_rotate(pp);
		}
	  }
	}
	else{
	error(2, "[%s %d] A bad thing has happened. Bye bye.\n",
	__FILE__,__LINE__);
	}
	return dH;
}

static int del_cmd(pCmd *pp, Cmd *c, int *count){
	pCmd p=*pp, *q;
	int dH=0;
	int tt;
	
	if(!p) return 0;
	if( 
	    		(tt=strcasecmp(c->name, p->name))<0 
	    
	   ){
	   if(del_cmd(&p->left, c,count)){
	  	p->bf++;
		if(p->bf == 0) dH=1;else
		if(p->bf == 2){
			if(p->right->bf==-1) right_rotate(&p->right);
			left_rotate(pp);
			if(p->bf==0) dH=1;
		}
	   }
	}else
	if( 
	 	tt>0
	   ){
	   if(del_cmd(&p->right, c,count)){
	   	p->bf--;
		if(p->bf == 0) dH=1;else
		if(p->bf == -2){
			if(p->left->bf==1) left_rotate(&p->left);
			right_rotate(pp);
			if(p->bf==0) dH=1;
		}
	   }
	}else{ /* got it! */
		(*count)--;
		if(p->right ==NULL){
			*pp=p->left;
			#ifdef _GUILE
			if(p->type & CMD_SCM)
			  scm_func[p->cmd.scm].idx=-1;
			#endif
			free(p);
			 return 1;
		}else
		if(p->left ==NULL){
			*pp=p->right;
			#ifdef _GUILE
			if(p->type & CMD_SCM)
			  scm_func[p->cmd.scm].idx=-1;
			#endif
			free(p);
			return 1;
		}else{
			q= &p->left;
			while( (*q)->right!=NULL ) q= &(*q)->right;
			p->name=strdup((*q)->name);
	       		p->help=strdup((*q)->help);
			p->type=(*q)->type;
			p->cmd=(*q)->cmd;
			(*count)++;

			(*q)->name=strdup(c->name);
			(*q)->help=strdup2(c->help);
			(*q)->type=c->type;
			(*q)->cmd=c->cmd;
			if(del_cmd(&p->left, c,count)){
				p->bf++;
				if(p->bf==0) dH=1;else
				if(p->bf==2){
					if(p->right->bf==-1) right_rotate(&p->right);
					left_rotate(pp); dH=1;
				}
			}
		}
	
	}
	return dH;
}

