/* msg.c        -private msges and notes 
 * 
 * Author: Tano Fotang, 1997,1998
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free 
 * Software Foundation; either version 2 of the License , or (at your option) 
 * any later version.
 * see the file COPYING for mre info.
 * 
 */

#include <forms.h>
#include <time.h>
#include <stdarg.h>
#include <ctype.h>
#include "aux.h"
#include "sula.h"
#include "chanwin.h"
#include "global.h"
#include "script.h"
#include "parser.h"
#include "dcc.h"
#include "setting.h"
#include "ignore.h"
#include "cmd.h"
#include "lag.h"
#include "scheme.h"
#include "hooks.h"
#include "flood.h"

extern Winstruct *Win;
/* 
 * topic, invite, privmsg , note & notice
 * 
 */
/****************************************************************
 * 
 * T O P I C                                    
 * 
 ****************************************************************/

extern void p_topic(void)
{
	char   *channel, *sender, *newtopic=NULL,
	 *nick, *host, *login;
	size_t  ll = strlen(Msg);
	Channel *chan;
	int to;
	assert(*(Msg+ll-1)!='\n' && *(Msg+ll-1)!='\r');
	channel = (char *) alloca(sizeof(char) * ll);
	sender = (char *) alloca(sizeof(char) * (8+ll));
	newtopic = (char *) malloc(sizeof(char) * ll);
	to=  Win-winstruct;
	if (sscanf(Msg, "%s TOPIC %s %[^\n]\n", sender, channel, newtopic) < 3)
		{free(newtopic);return;}
	ll = strlen(sender)+8;
	nick = (char *) alloca(sizeof(char) * (ll));
	host = (char *) alloca(sizeof(char) * (ll));
	login = (char *) alloca(sizeof(char) * (ll));
	if (sscanf(sender, "%[^!]!", nick) < 1)
		strcpy(nick,"<unknown>");
	if (sscanf(sender, "%*[^@]@%s", host) < 1)
		strcpy(host,"<unknown>");
	if (sscanf(sender, "%*[^!]!%[^@]@", login) < 1)
		strcpy(login,"<unknown>");
	else if(*login=='~'){
	    strshift(login,1);
	    sprintf(sender,"%s!%s@%s",nick,login,host);
	}
	chan = get_chan_byname(Win, channel);
	if (!chan)
		return;		/* fatal error. should quit program. well, next time i look at this */
	if(*newtopic==':')
	   strshift(newtopic,1);
	/*if(*newtopic unspace(newtopic);	  whitespaces alone
					  shldnt be considered a channel topic.*/
	if (!*newtopic) {
		chan->topic = NULL;
		if (!ignored(sender, IG_MISC) &&
		  (!(sflags&FLOOD_CHECK) ||
		    !flooding(sender,PUBLIC_FLOOD,FLOOD_TOPIC) ||
		     !check_msg_hook(PUB_FLOOD,
			                   Win-winstruct,"%s,%d %s",
		                           Win->server->name,Win->server->port,
					   Msg)
		  ) && 
		   !check_msg_hook(TOPIC,Win-winstruct,"%s,%d %s",
		                 Win->server->name,Win->server->port, Msg)
		) {
			if (gflags & SHOW_RAW_MSG)
				say(Msg,to,1);
			else {
				char    buf[256];
				if (sscanf(sender, "%*[^!]!%s", host) < 1)
					strcpy(host,"<unknown>");
				sprintf(buf, "%s (%s) has cleared the topic on %s", nick, host, channel);
				say(buf,to,1);
			}
		}
		update_topic(Win, channel, "<" sula_NAME sula_VERSION "> says no topic has been set");
	}
	else {
	  if(chan->topic) free(chan->topic);
	  chan->topic = strdup(newtopic);
	  if (!ignored(sender, IG_MISC) &&
	      (!(sflags&FLOOD_CHECK) || !flooding(sender,PUBLIC_FLOOD,FLOOD_TOPIC) ||
		     !check_msg_hook(PUB_FLOOD,
			                   Win-winstruct,"%s,%d %s",
		                           Win->server->name,Win->server->port,
					   Msg)
		  ) && 
		   !check_msg_hook(TOPIC,Win-winstruct,"%s,%d %s",
		                 Win->server->name,Win->server->port, Msg)
		) {

			if (gflags & SHOW_RAW_MSG)
				say(Msg,to,1);
			else {
				char   *buf;
				if (sscanf(sender, "%*[^@]@%s", host) < 1)
					strcpy(host,"<unknown>");
				fmt_string = "%n%l%h%c%p$";
				buf = format_msg(fmt_topic, nick, login, host, channel, newtopic);
				if (buf){
					say(buf,to,1);
					free(buf);
				}
			}
	   }
	   update_topic(Win, channel, newtopic);
	}
	free(newtopic);
}

#ifndef NOLAG
static int is_lag(const char *nick, const char *chan, Winstruct *win){
	struct timeval t;
	t.tv_usec=0;
	if(sscanf(chan,"__%u_%u", &t.tv_sec, &t.tv_usec)<1)
		return 0;
	#if PARANOID
	if(
	!strcasecmp(nick, win->server->nick)
	)
	#endif
	{
	struct timeval now;
	gettimeofday(&now,NULL);
	update_lag_display(win->server, now.tv_sec- t.tv_sec+
		    (float)((now.tv_usec- t.tv_usec)/ 1000000.0),
		     &t );
	}
	return 1;
}
#endif
/****************************************************************
* 
* I N V I T E                                  
* 
****************************************************************/

extern void p_invite(void)
{
	char   *sender, *nick, *channel;
	char   *login, *host;
	size_t  ll;
	int to=-1;

	ll = strlen(Msg);
	sender = (char *) alloca(sizeof(char) * (ll+8)); // <unknown>
	channel = (char *) alloca(sizeof(char) * ll);
	sscanf(Msg, "%s", sender);
	ll = strlen(sender)+8; // <unknown>
	nick = (char *) alloca(sizeof(char) * (ll));
	if (sscanf(sender, "%[^!]!%*s", nick) < 1)
		strcpy(nick,"<unknown>");
	if (sscanf(Msg, "%*s INVITE %*s :%s", channel) < 1)
		return;
	#ifndef NOLAG
	if(is_lag(nick, channel, Win)) return;
	#endif
	
	host = (char *) alloca(sizeof(char) * (ll));
	login = (char *) alloca(sizeof(char) * (ll));
	if (sscanf(sender, "%*[^@]@%s", host) < 1)
		strcpy(host,"<unknown>");
	if (sscanf(sender, "%*[^!]!%[^@]@", login) < 1)
		strcpy(login,"<unknown>");
	else if(*login=='~'){
	    strshift(login,1);
	    sprintf(sender,"%s!%s@%s",nick,login,host);
	}
	if (ignored(sender, IG_INVITE)) {
		if (gflags & INFORM_IGNORED) {
			char   *s, *buf;
			fmt_string = "%n%l%h%c%p$";
			buf = format_msg(fmt_ignored, nick, login, host, channel, "INVITE");
			if (!buf)
				return;
			s = (char *) malloc(sizeof(char) * (strlen(buf) + strlen(nick) + 20));
			if (!s) {
				error(-1,"Fuck, no mem..");
				return;
			}
			sprintf(s, "NOTICE %s :%s\n", nick, buf);
			sendto_server(Win, s);
			free(s); free(buf);
		}
		return;
	     }
	     else
	
  if((!(sflags&FLOOD_CHECK) || !flooding(sender,PRIVATE_FLOOD,FLOOD_INVITE) ||
	!check_msg_hook(PRIV_FLOOD,
			Win-winstruct,"%s,%d %s",
		        Win->server->name,
			Win->server->port,
			Msg)
	   ) && 
	    !check_msg_hook(INVITE,  Win-winstruct,"%s,%d %s",
		 Win->server->name,Win->server->port,Msg)
	) {
	char *buf;

	Win->server->lastInvite = strdup(channel);
	if (sflags & S_INVITE)
		addto_sender(sender, SS_INVITE);
	if ( Win->server->flag&SET_AWAY && (gflags & BEEP_AWAY))
			fl_ringbell(0);
	to= Win-winstruct;/*X==1? Win-winstruct:-1;*/
	if (gflags & SHOW_RAW_MSG)
		say(Msg,to,1);
	else {
		fmt_string = "%n%l%h%c%p$";
		buf = format_msg(fmt_invite, nick, login, host, channel, channel);
		if (buf){
			say(buf,to,1);
			free(buf);
		}
	}
	if (gflags & AUTO_INVITE) {
		buf=(char *) malloc(sizeof(char) * (strlen(channel)+40));
		if (gflags & VERBOSE_CLIENT){
			sprintf(buf, "Auto-accepting invitation to %s", channel);
			say(buf,to,1);
		}
		addto_cmd_sent(Win, "JOIN", channel);
		sprintf(buf, "JOIN  %s\n", channel);
		sendto_server(Win, buf);
		free(buf);
	}
  }//if((!flooding(
}

/****************************************************************
* 
* N O T E  N O T I C E                         
* 
*  i dont know if this works at all
****************************************************************/
extern void p_note(void)
{
	char   *buf;
	int     D = strlen(Msg);
	int to=-1;
	
	buf = (char *) malloc(sizeof(char) * D);
	if ((sscanf(Msg, "NOTICE %*s :%[^\n]\n", buf) < 1))
		{free(buf);return;}
	if (*buf == '#') {
		if(!check_msg_hook(NOTE, Win-winstruct,"%s,%d %s",
		 Win->server->name,Win->server->port, Msg)){
		*(buf + strlen(buf) - 1) = '\0';
		say2(to,1,"-%s- %s", Win->server->name, buf + 3);
		}
		free(buf);
		return;
	}
	else {
		char   *buf2, *email, *nick;

		int     D = strlen(Msg);

		email = (char *) malloc(sizeof(char) * D);
		nick = (char *) malloc(sizeof(char) * D);
		buf2 = (char *) malloc(sizeof(char) * D);

		if (sscanf(Msg, "%*s %*s %*s %*s %s", buf2) < 1)
			goto done;	/*nnote: buf2 is sender */
		if (ignored(buf2, IG_NOTE))
			/* dont reply. might cause a ping-pong endless loop */
			goto done;
		if(check_msg_hook(NOTE, Win-winstruct,"%s,%d %s",
		 Win->server->name,Win->server->port,Msg)) {goto done;}
		if (gflags & SHOW_RAW_MSG)
			say(Msg,to,0);
		else {
			int     H, M;
			char    d[] = "0000", h[] = "00", m[] = "00";

			if (sscanf(Msg, 
		"%*s %*s %*s %*s %[^!]!%s /%[^d:]d:%[^h]h:%[^m/]m/ %*s %[^\n]\n",
				   nick, email, d, h, m, buf2) < 6) {
				say2(to,0,"-%s- %s", Win->server->name, buf);
			}else{
				D = atoi(d);
				H = atoi(h);
				M = atoi(m);
			   say2(to,0,"-%s- Note from %s (%s) %s%s%s%s%s%s%d min%s ago:",
				 Win->server->name,
				 nick, email, D ? d : "", D ? "day" : "", D > 1 ? "s " : D ? " " : "", 
				 (H) ? h : "", H ? "hr" : "", H > 1 ? "s " : H ? " " : "", M, M != 1 ? "s" : "");
			say2(to,1,"\t%s", buf2);
			}
		}
		fl_ringbell(10);
		done:
	       free(email); free(nick);
	}
}

/****************************************************************/
/* 								*/
/* P R I V M S G                                        	*/
/*								*/
/* N O T I C E                                  		*/
/* 								*/
/****************************************************************/

extern void p_privmsg(int flag)
{

/*------------------------------------------------------*/
/* d o  d c c                                   	*/
/*------------------------------------------------------*/
	if (
	flag != NOTICE &&  /* this doesnt decrypt encrypted notices!  */
	ctcp_cmd())
		return;
/*------------------------------------------------------*/
/* d o  o t h e r s                             	*/
/*------------------------------------------------------*/
	else {
		static int ctcp_reply(const char *,
		const char *, const char *, 
		const char *, const char *);
		char   *sender, *nick, *name, *host,
		       *email , *dest;
		char   *msg=NULL;
		char   *fmt = NULL;
		size_t  ll;
		int     i;
		int to=Win-winstruct;

		ll = strlen(Msg);
		assert(*(Msg+ll-1)!='\n' && *(Msg+ll-1)!='\r');
		sender = (char *) alloca(sizeof(char) * (8+ll));
		dest = (char *) alloca(sizeof(char) * ll);
		msg = (char *) alloca(sizeof(char) * ll);
		if (flag == NOTICE)
			i = sscanf(Msg, "%s NOTICE %s :%[^\n]\n", sender, dest, msg);
		else
			i = sscanf(Msg, "%s PRIVMSG %s :%[^\n]\n", sender, dest, msg);
		if (i < 3) {
			if (i == 2) {
				sscanf(Msg, "%*s %*s %[^\n]\n", msg);
				say2(-1,1,"-%s- %s", sender, msg);
			}
			return;
		}
		ll = strlen(sender)+8;
		nick = (char *) alloca(sizeof(char) * ll);
		email = (char *) alloca(sizeof(char) * ll);
		if (sscanf(sender, "%[^!]!%s", nick, email) < 2) {
			/* is not nick!user@host : probably server error */
			say2(-1,1,"-%s- %s", sender, msg);
			return;
		}
		host = (char *) alloca(sizeof(char) * (ll));
		name = (char *) alloca(sizeof(char) * (ll));
		if(*email=='~') strshift(email,1);
		if (sscanf(email, "%[^@]@%s", name, host) < 2) {
			strcpy(host, "<unknown>");
			name = email;
		}
	#warning CTCP-REPLY flood check has been left out for now
		if (ctcp_reply(nick, name,host,	dest, msg))
			return;
		if (*dest == '#' || *dest == '&') {
			if (ignored(sender, flag == NOTICE ? IG_PUBNOTICE : IG_PUBMSG)) {
				char   *s = NULL;
				char *buf;

				if (flag == NOTICE || !(gflags & INFORM_IGNORED))
					return;
				fmt_string = "%n%l%h%c%p$";
				s = format_msg(fmt_ignored, nick, name, host, dest, "CHANNEL MSG");
				if (!s) return;
				buf = (char *) malloc(sizeof(char) * (strlen(s) + strlen(nick) + 15));
				sprintf(buf, "NOTICE %s :%s\n", nick, s);
				sendto_server(Win, buf);
				free(s); free(buf);
			        return;
			}
			if(flag == NOTICE) gflags |=DOING_NOTICE;
			if(((sflags&FLOOD_CHECK) && flooding(email,PUBLIC_FLOOD,FLOOD_PUBMSG) &&
	                    check_msg_hook(PUB_FLOOD,
			          Win-winstruct,"%s,%d %s",
		                  Win->server->name,
			          Win->server->port,
			          Msg)) ||
			    check_msg_hook(flag == NOTICE?PUBNOTICE:PUBMSG,
			           Win-winstruct,"%s,%d %s",
		 	           Win->server->name,Win->server->port, Msg)
	                  ){
			   if(flag == NOTICE) gflags &=~DOING_NOTICE;
			   return;
			   }
			if(flag == NOTICE) gflags &=~DOING_NOTICE;
			if (!get_user_byuser(get_chan_byname(Win, dest), nick))
				/* sender of msg is not  on this channel */
				fmt = flag == NOTICE ? fmt_pub_notice3 : fmt_pub_msg3;
			else if (strcasecmp(dest, Win->chanCur->name))
				/* this isnt my current channel */
				fmt = flag == NOTICE ? fmt_pub_notice2 : fmt_pub_msg2;
			else
				fmt = flag == NOTICE ? fmt_pub_notice : fmt_pub_msg;
		}
		else {		/* this is a private msg/notice */
			if (ignored(sender, flag == NOTICE ? IG_PRIVNOTICE : IG_PRIVMSG)) {
				char   *s = NULL, *buf;

				if (flag == NOTICE || !(gflags & INFORM_IGNORED))
					return;
				fmt_string = "%n%l%h%c%p$";
				s = format_msg(fmt_ignored, nick, name, host, dest, "PRIVATE MSG");
				if (!s)
					return;
				buf = (char *) malloc(sizeof(char) * (strlen(s) + 
					strlen(nick) + 15));
				sprintf(buf, "NOTICE %s :%s\n", nick, s);
				sendto_server(Win, buf);
				free(s); free(buf);
				return;
			}
			if(flag == NOTICE) gflags |=DOING_NOTICE;
			if((sflags&FLOOD_CHECK &&
			     flooding(email,PRIVATE_FLOOD,FLOOD_PRIVMSG) &&
	                    check_msg_hook(PRIV_FLOOD,
			          Win-winstruct,"%s,%d %s",
		                  Win->server->name,
			          Win->server->port,
			          Msg)) ||
			    check_msg_hook(flag == NOTICE?PRIVNOTICE:PRIVMSG, 
			          Win-winstruct,"%s,%d %s",
		 		  Win->server->name,Win->server->port,Msg)
	                  ){
			  if(flag == NOTICE)  gflags &=~DOING_NOTICE;
			   return;
			   }
			if(flag == NOTICE){
			  gflags &=~DOING_NOTICE;
			  if (sflags & S_NOTICE)
			 	addto_sender(sender, SS_NOTICE);
			}
			else if (sflags & S_MSG)
				addto_sender(sender, SS_MSG);
			fmt = flag == NOTICE ? fmt_priv_notice : fmt_priv_msg;
			if ((gflags & BEEP_MSG) || ( Win->server->flag&SET_AWAY && (gflags & BEEP_AWAY)))
				fl_ringbell(0);
		}
		if (gflags & SHOW_RAW_MSG) 
			say(Msg,to,0);
		else {
			char   *ptr;
			ll=strlen(msg);
			ctcp_unquote_it(msg,&ll);
			fmt_string = "%f%n%l%h%c%p%z%Z$";
			ptr = format_msg(
				fmt, Win->server->name,
				nick, name, host, dest, msg,
				strlen(Msg), Win->server->read);
			if (ptr){
				say(ptr,to,0);
				free(ptr);
			}
		}
	}
}


static int ctcp_reply(const char *nick, const char *name, const char *host,
const char *dest,
      const char *msg)
{

	/* process a cTCP reply */
		if (msg && *msg != 0x01)
		return 0;
else{
	char   *str;
	char   *buf, *ptr;
	size_t  ll = strlen(msg);
	
	
	buf = (char *) alloca(sizeof(char) * ll);
	str = (char *)(msg);
	ptr = buf;
	while (*++str && *str != 0x01)
		*ptr++ = *str;
	if (*str != 0x01)
		return 0;
	*ptr = '\0';		/* ignore all else after 0x01 */
	if(check_msg_hook(CTCP_REPLY,  Win-winstruct,"%s,%d %s",
		 Win->server->name,Win->server->port,Msg)) return 1;
	if (gflags & SHOW_RAW_MSG) {
		say(Msg,Win-winstruct,1);
		return 1;
	}

	ll=strlen(buf);
	ctcp_unquote_it(buf,&ll);
	str = nextstr(buf, 1);
	if (!strcasecmp(str, "PING")) {
		struct timeval t, t2;
		char s[32];
		int i=sscanf(buf, "%*s %u %u", &t.tv_sec, &t.tv_usec);
		free(str);
		if(i<1) return 1;
		if(i<2) t.tv_usec=0;
		gettimeofday(&t2, NULL);
		sprintf(s, "%f seconds",
		 (float)(t2.tv_sec-t.tv_sec+
		    (float)((t2.tv_usec- t.tv_usec)/ 1000000.0)
		 )
		 );
		fmt_string="%f%n%l%h%p%z%Z$";
		ptr=format_msg(fmt_ctcp_reply,
		"PING",nick,name, host,s,strlen(Msg), Win->server->read);
		if(ptr){
		      say(ptr,Win-winstruct,1);
		      free(ptr);
		}
	}
	else{
		rmstr(buf, 0);/*rm ctcp cmdname*/
		fmt_string="%f%n%l%h%p%z%Z$";
		ptr=format_msg(fmt_ctcp_reply,
		str,nick,name, host, buf,strlen(Msg), Win->server->read);
		if(ptr){
		      say(ptr,Win-winstruct,1);
		      free(ptr);
		}
		free(str);
	}
	return 1;
 }
}
