/* util.c	- ni idea what these are

    Tano Fotang, 1997/98

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License , or
    (at your option) any later version.
    see the file COPYING for details.

*/

#include <errno.h>
#include <sys/time.h>
#include <stdarg.h>
#include <pwd.h>
#include <ctype.h>
#include "aux.h"
#include "util.h"

Sigfunc *Signal(int signo, Sigfunc *func)
/* same as signal(2) but repeats interrupted system calls
 */
{
	struct sigaction act, oact;

	act.sa_handler=func;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	if(signo==SIGALRM){
#ifdef SA_INTERRUPT
		act.sa_flags|=SA_INTERRUPT; 
#endif
	}else{
#ifdef SA_RESTART
		act.sa_flags|=SA_RESTART;
#endif
	}
	if(sigaction(signo, &act, &oact)<0) return (SIG_ERR);
	return (oact.sa_handler);
}

int    delay(unsigned long microsecs)
{
	struct timeval tv;

	tv.tv_sec = 0;
	tv.tv_usec = microsecs;
	if(select(0, NULL, NULL, NULL, &tv)<0) return errno;
	return 0;
}
extern void new_str2args(char *buf, int *argc, char **args, size_t size){
	/* buf is trashed after this call
	size is the size of args (*args===args[size]
	*/
	*argc=0;size--;
	while(*buf!='\0' && *argc<size){
		while( *buf==' '  || *buf=='\t'
		#if 0 
		 || *buf=='\n'
		#endif
		) *buf++='\0';
		if(*buf) {*args++=buf; (*argc)++;}
		while( *buf!='\0' && *buf!=' ' && *buf!='\t'
		#if 0 
		&& *buf!='\n'
		#endif
		) buf++;
	}
	*args='\0';
}
extern char *
        expand_tilde(const char *file)
{
/* 
 * expand ~ ina pathname  */
	char   *fullpath;
	char *pname=(char *)file;
	if (*pname != '~')
		return strdup(pname);
	if (*(pname + 1) == 0 || *++pname == '/') {
		char   *path;

		if (!(path = getenv("HOME")))
			return NULL;
		if (*(pname + 1) == 0)
			return strdup(path);
		fullpath = (char *) malloc(sizeof(char) * (
		strlen(path) + strlen(pname) + 8));
		if (!fullpath) 
			return NULL;
		sprintf(fullpath, "%s%s", path, pname);
		return fullpath;
	}
	else {
		struct passwd *pwd;

		if (!strchr(pname, '/')) {	/* ~tt */
			if (!(pwd = getpwnam(pname)))
				return NULL;
			return strdup(pwd->pw_dir);
		}
		else {		
				 /* ~tt/ttt  */
			pwd = getpwnam(strxstr(pname, "/"));
			if (!pwd)
				return NULL;
			fullpath = (char *) malloc(sizeof(char) * (strlen(pwd->pw_dir) +
						      strlen  (pname) + 3));
			if (!fullpath) 
				return NULL;
			sprintf(fullpath, "%s%s", pwd->pw_dir, strchr(pname, '/'));
			return fullpath;
		}
	}
}
void unspace(const char *s){
/* remove leading blanks */
 char *p=(char *)s;
 while(isspace(*p)) p++;
 memmove((char *)s, p, strlen(p)+1);
}

void unescape(const char *str){
	char *p=(char *)str;
	while(isgraph(*p)) p++;
	*p='\0';
}
void uncomment (char *s, int c)
{
/* squeeze out parts of s beginning with c */
  while (*s && *s != c)
    s++;
  *s = '\0';
}
int find_pos(const char *str, unsigned int n){
/*
return start pos of (n)th word. words are assumed to be seperated by blanks
n=0 ->1st word
return value:
strlen(s): if n>number of words in s 
>=0: start pos
 */
	register i;
	char *s=(char *)str;

	while(*s==' ' || *s=='\t') s++;
	i=1;// positioned on 1st word
	while(*s && i<n){
		while(*s && (*s!=' ' && *s!='\t')) s++;
		if(*s) i++;
		while(*s==' ' || *s=='\t') s++;
	}
	return (s-str);
}
char * nextstr(const char *str, unsigned int n){
/* 
 * get nth word of a string .first word: n=1 */
	register i;
	char *s=(char *)str, *ptr;
	 char *buf;

	while(*s==' ' || *s=='\t') s++;
	i=1;// positioned on 1st word
	while(*s && i<n){
		while(*s && (*s!=' ' && *s!='\t')) s++;
		if(*s) i++;
		while(*s==' ' || *s=='\t') s++;
	}
	ptr=s;//start of nth word
	while(*s && (*s!=' ' && *s!='\t')) s++;
	i=s-ptr;
	buf=(char *)malloc(sizeof(char)*(1+i));
	if(buf==NULL) return NULL;
	memcpy(buf,ptr, i);
	*(buf+i)=0;
	return buf;
}

void rmstr(const char *str, unsigned int n){
/* delete nth word (n>0) from str */
if((str && *str)){
	register i;
	char *s=(char *)str, *ptr;

	i=0;// positioned on str
	while(*s && i<n){
		while(*s && (*s!=' ' && *s!='\t')) s++;
		i++;
		if(i==n) break;
		while(*s==' ' || *s=='\t') s++;
	}
	ptr=s;
	// ptr is the start of blanks before nth word
	while(*s==' ' || *s=='\t') s++; // remove leading blanks
	while(*s && (*s!=' ' && *s!='\t')) s++; // remove word
	if(n==0) while(*s==' ' || *s=='\t') s++;// remove leading blanks
	if(*ptr) while((*ptr++=*s))
	    s++;
}
}

extern char *
        strdup2(const char *str)
{
	char   *tmp = NULL;

	if (str == NULL || !(*str))
		return NULL;
	tmp = (char *) malloc(sizeof(char) * (strlen(str) + 1));

	if (tmp == NULL)
		return NULL;
	strcpy(tmp, str);
	return tmp;
}
/*
extern char *getmemory(unsigned n){
	char *buf=(char *)malloc(sizeof(char)*n);
	if(buf==NULL)
		perror("Memory failure");
	return buf;
}*/
extern char *
        strcp(const char *s, size_t n)
{
/* 
 * return first n letters of s */

	if (!s)
		return NULL;
	if (n > strlen(s))
		return strdup(s);
	else {
		char   *buf;
		 buf= malloc(sizeof(char)*(n+1));
		 if(buf==NULL) return NULL;
		 strncpy(buf,s,n);
		*(buf + n) = '\0';
		return buf;
	}
}

char   *strxstr(const char *s1, const char *s2)
/* 
 * return s1 up to and excluding s2 */
{
	char   *t;

	if (!s1 || !(t = strstr(s1, s2)))
		return NULL;
	else {
		size_t len=t-s1;
		char   *tmp = malloc(sizeof(char)*(len+1));
		memcpy(tmp,s1, len);
		*(tmp+len)=0;
		return tmp;
	}
}

char   *stristr(const char *s1, const char *s2)
/* 
 * return malloc'ed space containing s1 up to and including s2 */
{
	char   *t;

	if (!s1 || *s1==0) return NULL;
	 if((t = strstr(s1, s2))==NULL)
		return strdup(s1);
	else{
		char   *tmp;
		tmp = strdup(s1);
		*(tmp + strlen(s2) + (t-s1))=0;
		return tmp;
	}
}

char   *strsstr(const char *s1, const char *s2)
/* 
 * return s1 as from and excluding s2 */
{
	char   *t;

	if (!s1 || !(*s1))
		return NULL;
	t = strstr(s1, s2);
	if (t)
		return strdup2(t + strlen(s2));
	else
		return NULL;
}
#if 1
char   *
        clean(const char *s)
{
/* 
 * remove tabs n white spaces from start of s and return copy */

	if (!s || !(*s))
		return NULL;
	else{

	char   *p = (char *)(s);
	while (*p == ' ' || *p == '\t')
		p++;
	return *p?strdup(p):NULL;
	}
}
#endif
char   *
        lowercase(const char *s)
/* 
 * convert string to lowercase..   */
{
	if (s==NULL || *s==0)
		return NULL;
	else{
	char   *t;
	t = (char *) malloc(sizeof(char) * (strlen(s) + 1));
	if (!t)
		return NULL; 
	else{char *p = t;
	while ((*p++ = isupper(*s) ? tolower(*s++) : *s++));
	return t;
	}
	}
}

char   *
        uppercase(const char *s)
/* 
 * convert string to lowercase..   */
{
	if (s==NULL || *s==0)
		return NULL;
	else{
	char   *t;
	t = (char *) malloc(sizeof(char) * (strlen(s) + 1));
	if (!t)
		return NULL;
	else{
	char *p = t;
	while ((*p++ = toupper(*s++)));
	return t;
	}
	}
}
void   lowercase2(const char *s)
/* 
 * convert string to lowercase..   */
{
	char *p =(char *)s;
	while ((*p++ = isupper(*s) ? tolower(*s++) : *s++));
}

void uppercase2(const char *s)
/* 
 * convert string to lowercase..   */
{
	char   *p=(char *)s;
	while ((*p++ = toupper(*s++)));
}

char   *strdchr(const char *t, int c)
{
/* 
 * remove a ll c from t  */
	char *ptr;
	char   *s;

	if (!t)
		return NULL;
	s = (char *) malloc(sizeof(char) * (strlen(t) + 1));

	if (!s)
		return NULL;
	ptr=s;
	while(*t){
	  if(*t!=c) *ptr++=*t;
	  t++;
	}
	*ptr=0;
	return s;
}
